unit Main ;

{ Ukazka pouzivani pohledu (vytvorenych ve WinBasi602) jakozto detskych oken v
  Delphi aplikaci }

interface
{ Do klausule uses pridana unita WinBase }
uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls,WinBase,
  View602, WBNavig, MsgFrame;

type
{Hlavni okno TMainForm MDI aplikace odvozeno z uzivatelskeho formulare
 TWBMainForm:}
  TMainForm = class(TWBaseServer602)
    MainMenu1: TMainMenu;
    Window1: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    OpenDialog: TOpenDialog;
    WindowMinimizeItem: TMenuItem;
    SpeedPanel: TPanel;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    CutBtn: TSpeedButton;
    CopyBtn: TSpeedButton;
    PasteBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    StatusBar: TStatusBar;
    PohledyDoTabulek: TMenuItem;
    PracCinMENUITEM: TMenuItem;
    ZamestnanMENUITEM: TMenuItem;
    PohledyDoDotazu1: TMenuItem;
    Seznam1: TMenuItem;
    Graf1: TMenuItem;
    Oddeleni1: TMenuItem;
    Tisk1: TMenuItem;
    Nastavenitisku1: TMenuItem;
    Tisk2: TMenuItem;
    Spojeni: TMenuItem;
    Pripojit: TMenuItem;
    Odpojit: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    Pracovnici: TView602;
    PracovniCinnosti: TView602;
    Dot_omezen: TView602;
    Dot_relace: TView602;
    WBNavig1: TWBNavig;
    MsgFrame1: TMsgFrame;
    procedure FormCreate(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure ZamestnanciClick(Sender: TObject);
    procedure PracovniCinnostiClick(Sender: TObject);
    procedure PripojitClick(Sender: TObject);
    procedure OdpojitClick(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Seznam1Click(Sender: TObject);
    procedure Oddeleni1Click(Sender: TObject);
    procedure WBNavig1BeforeDelete(Sender: TObject; var IsOk: Boolean);
    procedure MsgFrame1SetStatusText(Sender: TObject;
      TypObsahu: TWBTypObsahu; Obsah: string);
    procedure MsgFrame1SetToolBar(Sender: TObject; WB_TB_Typ: TWB_TB_Typ);
  private
    procedure VisibleMenu(Visibl: Boolean);
    procedure ShowHint(Sender: TObject);
  public

  end;

var
  MainForm: TMainForm;

implementation

uses LogForm;

{$R *.DFM}

procedure TMainForm.VisibleMenu(Visibl: Boolean);
begin
 Pripojit.Enabled := not Visibl;
 Odpojit.Enabled := Visibl;

 PohledyDoTabulek.Enabled := Visibl;
 PohledyDoDotazu1.Enabled := Visibl;
 Tisk1.Enabled := Visibl;
 Window1.Enabled  := Visibl;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusBar.Panels[0].Text := Application.Hint;
  StatusBar.Panels[1].Text := ' ';
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure TMainForm.ZamestnanciClick(Sender: TObject);
begin
  Pracovnici.Toggle;
end;(************************** ****************** ****************************)

procedure TMainForm.PracovniCinnostiClick(Sender: TObject);
begin
 if PracCinMENUITEM.Checked = False then
   begin
     PracCinMENUITEM.Checked := True;
     PracovniCinnosti.Open;
   end
 else
   begin
     PracCinMENUITEM.Checked := False;
     PracovniCinnosti.Close;
   end;
end;(************************** ****************** ****************************)

procedure list_server_names;
//Procedra napln FormLogin.ComboBox1 seznamem registrovanch server WinBase602
const key = 'SOFTWARE\Software602\WinBase602\Database';
var   server_name :array[0..126] of Char;
      polozka : Integer;
      h_Key: HKEY;
begin
 if RegOpenKeyEx(HKEY_LOCAL_MACHINE, key, 0, KEY_READ, h_Key) <> ERROR_SUCCESS
   then exit;
 polozka := 0;
 while TRUE do begin
  if RegEnumKey(h_Key, polozka, server_name, SizeOf(server_name)) <> ERROR_SUCCESS
    then System.break;
  FormLogin.ComboBox1.Items.Add(string(@server_name));
  inc(polozka);
 end;
  RegCloseKey(h_Key);
  FormLogin.ComboBox1.ItemIndex := 0;
end;

procedure TMainForm.PripojitClick(Sender: TObject);
const Appl = 'PER_AGENDA';
      NameU = nil;
      Password = nil;
var Uspech: Boolean;
    Server: string; //Server = 'WB5';
begin
// Pkazov dek programu wb_d_cmp.exe me obsahovat jedin parametr - nzev
// serveru WinBase602
  if ParamStr(1) = '' then  begin
  // Jmno serveru nebylo zadno z pkazovho dku, pkazov dek neobsahuje
  // tedy dn parametry. V takovm ppad je zobrazen dialogov box pro vbr
  // serveru z mnoiny registrovanch server WinBase602.
    try
     FormLogin := TFormLogin.Create(self);
     list_server_names;// Naplnn ComboBoxu seznamem server WinBase602
     FormLogin.ShowModal;
     Server := FormLogin.ComboBox1.Text;
    finally
     FormLogin.Free;
    end;
  end else
  // Jmno serveru bylo zadno z pkazovho dku jako parametr
  // nap. wb_d_cmp.exe WB5, je-li jmno serveru WB5 :
    Server := ParamStr(1);

  //  Klient se napoji na WinBsi a spusti aplikaci PER_AGENDA :
  if not WBInit(PChar(Server), NameU, Password, Appl) then  close;
 Uspech := Open_project('MIN_PLAT');
 if (Uspech = False) then Info_box('Chyba','Nelze otevrit projekt');
 VisibleMenu(True);
end;

procedure TMainForm.OdpojitClick(Sender: TObject);
begin
 WBEnd;
 VisibleMenu(False);
end;

procedure TMainForm.Konec1Click(Sender: TObject);
begin
{o odpojeni se od serveru se automaticky postara predek TWBMainForm}
 close;
end;

procedure TMainForm.Seznam1Click(Sender: TObject);
begin
  Dot_omezen.Open;
end;

procedure TMainForm.Oddeleni1Click(Sender: TObject);
begin
  Dot_relace.Open;
end;

procedure TMainForm.WBNavig1BeforeDelete(Sender: TObject;
var IsOk: Boolean);
begin
 if MessageDlg('Skuten chcete zruit zznam?', mtInformation,
    [mbYes, mbNo], 0) = mrYes then IsOk := True
 else IsOk := False;
end;

procedure TMainForm.MsgFrame1SetStatusText(Sender: TObject;
  TypObsahu: TWBTypObsahu; Obsah: string);
begin
  case TypObsahu of
   toText    :{text };
   {cisla zaznamu do praveho panelu :}
   toNoRecord:MainForm.StatusBar.Panels[1].Text := ' NoRec  ' + Obsah;
  end;
end;

procedure TMainForm.MsgFrame1SetToolBar(Sender: TObject;
  WB_TB_Typ: TWB_TB_Typ);
begin
// Demonstrace nastavovani toolbaru :
// (uplny vycet konstant typu WB_TB_... najdete v jednotce WinBase.pas ci v manualu
// Tyto konstanty odpovdaj jednotlivym typum winbasovskych oken.)

 case WB_TB_Typ of
  wttUNKNOWN    : begin
    WBNavig1.Visible := False;
                     end;
  wttDEFAULT    : begin
    WBNavig1.Visible := False;
                     end;
  wttVIEW       : begin
    WBNavig1.Enabled := True;
    WBNavig1.Visible := True;
    WBNavig1.VisibleButtons := [nbFirst,nbPrior,nbNext,nbLast,
                                            nbInsert,nbDelete,nbRefresh];

                     end;
  wttHIST       : begin
    WBNavig1.Visible := True;
    WBNavig1.Enabled := True;
    WBNavig1.VisibleButtons := [nbFirst,nbPrior,nbNext,nbLast];
                     end;
  wttEDITTEXT   : begin
    WBNavig1.Visible := False;
                     end;
 end;
end;

end.
