{************************************************************************
 * (C) Pavel Kubricht, 1997                                             *
 * Verze 1.0 z: unor, 1997                                              *
 ************************************************************************
Obsah jednotky MsgFrame: Implementace a vyvoz komponent TMsgFrame, TWBaseServer602
Jednotka MsgFrame vyvazi :

 1) Komponentu TMsgFrame, ktera implementuje radu udalosti, ktere nastanou,
 obdrzi-li hlavni okno MDI aplikace
    a) Prislusnou automaticky generovanou zpravu (viz v manualu Automaticky
 generovane zpravy, Prijem automatickych zprav v externich jazycich) nesenou
 ve WM_COMMAND. Napr. zpravu NOTIF_RECENTER (viz tez WinBase.pas) oznamujici,
 ze byl vybran novy zaznam v pohledu - odpovidajici udalost je OnRecenter.
 Nazvy udalosti jsou vytvoreny tak, ze predpona NOTIF_ je nahrazena predponou On .
    b) Libovolou zpravu WM_COMMAND generovanou WinBasi, ktera nese ve wParam vami
 definovane cislo z uzavreneho intervalu 1001 az 60000 (viz v manualu: Zpravy
 zasilane aplikacnimu programu - cislovani zprav). Prislusna udalost
 je OnOtherWMCmdFrom602 (udalost pro zpravy WM_COMMAND zasilane z WinBase602,
 ale jine nez automaticky generovane zpravy). V prislusnem Eventhandleru pak
 provedete dle hodnoty wParam prislusne zpracovani. Napr. chcete-li implementovat
 kod tlacitka ve winbasovskem pohledu nikoli ve WinBasi, ale v Delphi, pak nechte
 tlacitko vyslat zpravu napr 1001 kdykoli na nej bude kliknuto. (pro cisla
 zprav si muzete zavest samovysvetlujici identifikatory). V uvedenem EventHandleru
 pak muzete napsat if Msg.wParam = 1001 then (* Zpracovani zpravy v Delphi *).
    c)Dve winbasovske zpravy pro ovladani stavove listy a nastrojove listy :
 SZM_SETSTATUSTEXT, SZM_SETTOOLBAR - ukazka viz projekt WB_D_CMP.DPR + jednotky

 2) Tridu TWBaseServer602, kterou pouzijete jako predka pro hlavni MDI okno
 vasi MDI aplikace (a ktera je analogii tridy TWBParent - viz WB_D_API.RTF).
 Vzhledem k tomu, ze ramcove okno budete vytvaret jako potomka tridy
 TWBaseServer602, musi byt unita MsgFrame umistena v sekci uses hlavniho MDI okna
 To muzete udelat rucne, nebo automaticky, umistite-li do hlavniho MDI okna
 komponentu TMsgFrame.
 }
unit MsgFrame;

interface

uses
  Windows, Messages, SysUtils, Classes,Forms, WinBase, View602;

type
{ typy toolbaru spjatych s winbasovskou zpravou SZM_SETTOOLBAR :}
TWB_TB_Typ =(wttUNKNOWN,wttDEFAULT,wttVIEW,wttVIEWNOMOVE,wttVIEWPROJ,wttVIEWQUERY,wttHIST,wttINDEX,wttEDITTEXT,wttPREVIEW);
TWBsetToolBarEvent = procedure(Sender :TObject;WB_TB_Typ: TWB_TB_Typ) of object;
TWBTypObsahu = (toText,toNoRecord);// Je-li TypObsahu = toNoRecord, m Obsah vznam sla resp. sel
// (nap. intern/extern slo aktualnho zznamu), je-li TypObsahu = toText, m Obsah vznam textu
// (nap. npovda k polokm menu).

TWBsetStatusTextEvent = procedure(Sender:TObject;TypObsahu:TWBTypObsahu;Obsah:string) of object;
TWBWM = procedure(var Msg: TMessage) of object;

TMsgFrame = class(TComponent) ////////////////////////////////////////////////////
 private
  FOnSetToolBar    :TWBsetToolBarEvent;
  FOnSetStatusText :TWBsetStatusTextEvent;
  FOnCreate           :TWBEvent;
  FOnDestroy          :TWBEvent;
  FOnRecenter         :TWBEvent;
  FOnChange           :TWBEvent;
  FOnReset_Record     :TWBEvent;
  FOnReset_View       :TWBEvent;
  FOnSubCursor       :TWBEvent;
  FOnSuperCursor      :TWBEvent;
  FOnCreate_Dependent:TWBEvent;
  FOnDestroy_Dependent:TWBEvent;
  FOnCreate_Editor   :TWBEvent;
  FOnDestroy_Editor   :TWBEvent;
  FOnCreate_Viewer   :TWBEvent;
  FOnDestroy_Viewer   :TWBEvent;
  FOnOtherWMCmdFrom602:TWBEvent;
 published
  property OnCreate:TWBEvent read FOnCreate  write FOnCreate ;
  property OnDestroy:TWBEvent read FOnDestroy  write FOnDestroy ;
  property OnRecenter:TWBEvent read FOnRecenter  write FOnRecenter ;
  property OnChange: TWBEvent read FOnChange  write FOnChange ;
  property OnReset_Record:TWBEvent read FOnReset_Record write FOnReset_Record;
  property OnReset_View:TWBEvent read FOnReset_View write FOnReset_View ;
  property OnSubCursor:TWBEvent read FOnSubCursor write FOnSubCursor;
  property OnSuperCursor:TWBEvent read FOnSuperCursor write FOnSuperCursor;
  property OnCreate_Dependent:TWBEvent read FOnCreate_Dependent write FOnCreate_Dependent;
  property OnDestroy_Dependent: TWBEvent read FOnDestroy_Dependent write FOnDestroy_Dependent;
  property OnCreate_Editor: TWBEvent read FOnCreate_Editor write FOnCreate_Editor;
  property OnDestroy_Editor:TWBEvent read FOnDestroy_Editor write FOnDestroy_Editor;
  property OnCreate_Viewer:TWBEvent read FOnCreate_Viewer write FOnCreate_Viewer;
  property OnDestroy_Viewer:TWBEvent read FOnDestroy_Viewer write FOnDestroy_Viewer;

  property OnOtherWMCmdFrom602:TWBEvent read FOnOtherWMCmdFrom602 write FOnOtherWMCmdFrom602;

  property OnSetToolBar: TWBsetToolBarEvent read FOnSetToolBar write FOnSetToolBar;
  property OnSetStatusText:TWBsetStatusTextEvent read FOnSetStatusText write FOnSetStatusText;
end;

{ Druhy chyb, ktere mohou vzniknout v metode WBInit: }
  TIniErr = (WBINI_LINKERR,WBINI_INTERFERR,WBINI_LOGERR,WBINI_SETAPPLERR);

  TWBaseServer602 = class(TForm) ///////////////////////////////////////////////
  private
    hHlMenu, hWinMenu: HMENU;
   { Flags - Urceni zda hlavni okno bude pouzivat ovladaci a stavovou listu
      z WinBase602 ci z Delphi :}
    Flags: integer;
   { Indikuje pripojeni klienta na WinBasi: }
    Logged : boolean;
   { Promenna pro prubezne ukladani informaci o kontextu komunikace : }
    cd : cdp_t;
  protected
   { Zobrazi okenka chybovych hlaseni pro chyby vznikle ve funkci WBInit: }
    procedure WBInitErr(ErrType : TIniErr; err : integer);virtual;
  {Slouzi k nastaveni ci vyberu Delphovskeho toolbaru v zavislosti na typu
  winbasovskeho okna urceneho winbasovskou zpravou SZM_SETTOOLBAR: }
    procedure SZMSETTOOLBAR (var Msg: TMessage); message SZM_SETTOOLBAR;
  {Slouzi k ovldn Delphovskeho statusbaru na zaklade winbasovske zpravy
   SZM_SETSTATUSTEXT: }
    procedure SZMSETSTATUSTEXT(var Msg: TMessage); message SZM_SETSTATUSTEXT;
  {Slouzi ke zpracovani zprav WM_COMMAND prijatych z WinBase602: }
    procedure WMCOMMAND(var Msg: TMessage); message WM_COMMAND;
  public
   { Create pouzit pro akce inicializujici WinBasi : }
   constructor Create(AOwner: TComponent);override;
   { Zajisti odpojeni od WinBase602: }
   destructor Destroy; override;
   { Provadi pripojeni klienta k WinBasi a nastavuje Logged: }
   function WBInit(Server, Name, Password, Appl : PCHar) : Boolean; virtual;
   { Provadi odpojeni klienta od WinBase: }
   procedure WBEnd;
   { Slouzi k predavani zprav WinBasi :}
    procedure WndProc(var Msg: TMessage); override;
  published
  end;

procedure Register;

implementation

procedure TWBaseServer602.WBInitErr(ErrType : TIniErr; err : integer);
begin
 case ErrType of
   WBINI_LINKERR,
   WBINI_INTERFERR:  Kernel_error_box(err);
   WBINI_LOGERR:     Info_box('Chyba','Chybn heslo');
   WBINI_SETAPPLERR: Info_box('Chyba','Zadan aplikace v databzi nen');
 end;
end;

constructor TWBaseServer602.Create(AOwner: TComponent);
var WndMnuIndex: Integer;
begin
 inherited Create(AOwner);
 {Inicializace promenne kontextu komunikace cd : }
   cd := cdp_alloc();
   cdp_init(cd);

{Parametry hlavniho okna MDI aplikace, ktere musime predat WinBasi :}
{ 1) Nastaveni Flags: Urceni, ze hlavni okno bude pouzivat
     ovladaci a stavovou listu z Delphi.
}
   Flags := WBF_NO_TOOLBAR or WBF_NO_STATUSBAR;
{ 2)Nastaveni indexu submenu Window:}
 if (WindowMenu <> nil) then
   {Poradove cislo submenu Window v hlavnim menu :}
  WndMnuIndex := WindowMenu.MenuIndex
 else
   {Submenu Window neexistuje: }
  WndMnuIndex := -1;

//WinBase zjisti,kdo je MDIFrame a MDIClient :
Init_window_env(WindowHandle, ClientHandle, WndMnuIndex, Flags);
{Pokud se pri uzavreni nebo opusteni editoru ma vratit puvodni menu, musi byt
 predem registrovano procedurou Register_ext_menu:}

  hHlMenu := GetMenu(WindowHandle);
  if WindowMenu <> nil then
  begin
    hWinMenu := GetSubMenu(hHlMenu, WndMnuIndex);
    Register_ext_menu(WindowHandle, hHlMenu, hWinMenu);
  end;
end;

destructor TWBaseServer602.Destroy;
begin
  WBEnd;
  inherited Destroy;
end;

function TWBaseServer602.WBinit(Server, Name, Password, Appl : PCHar) : boolean;
(****** Metoda implementuje vlastn napojen na WinBasi ***********************)
var err : integer; { cislo chyby }
begin
 Logged := FALSE; { jeste nejsme prihlaseni}
 WBInit := TRUE; { bude-li nekde neuspech, nastavi se na FALSE }
 err := link_kernel(Server, SW_MINIMIZE); { volba nebo spusteni serveru }
 if err <> KSE_OK then
 begin {1}    { chyba v link_kernel }
   WBInitErr(WBINI_LINKERR, err);
   WBInit := FALSE;  { vystup z fce WBInit pri neuspechu}
 end  {1}
 else
 begin  {1}  { uspech v link_kernel }
   err := interf_init(cd, 0); { pripojeni klienta na server }
   if err <> KSE_OK then
   begin {2}  { chyba v interf_init }
    { unlink_kernel();}
     WBInitErr(WBINI_INTERFERR, err);
     WBInit := FALSE; { vystup z fce WBInit pri neuspechu}
   end {2}
   else
   begin {2} { uspech v interf_init }
     if Name = nil then
       begin {3}
	 Logged := Alogin(0); { Dotaz na Name a Password }
       end {3}
       else
       begin {3}
	 if Password = nil then
           Password := '';
	   Logged := not Login(Name, Password);
	   if (not Logged) then
	     WBInitErr(WBINI_LOGERR, 0);
       end; {3}
    	  if not Logged then
	    begin {4}  { Neuspesne prihlaseni klienta : Logged = FALSE; }
	      interf_close;
             { unlink_kernel;}
	      WBInit := FALSE; { vystup z fce WBInit pri neuspechu}
	    end {4}
            else { Uspesne prihlaseni klienta : Logged = TRUE; }
              if (Appl <> nil) and Set_application(Appl) then
	      begin {5} { pri uspechu vraci Set_application() FALSE }
	        WBInitErr(WBINI_SETAPPLERR, Sz_error);
                LogOut;
                Logged := false;
		interf_close();
               {unlink_kernel();}
		WBInit := false; { vystup z fce WBInit pri neuspechu }
	      end {5}
   end; {2}
 end; {1}
end; { Konec WBInit }

procedure TWBaseServer602.WBEnd;
(****** Metoda implementuje vlastn odpojen od WinBase ***********************)
begin
 if Logged then
   begin
{ Spolu s ukoncenim WinBase602 uzavreme vsechny jeji pohledy :}
    Close_all_views;
    Logout;
    interf_close;
   { unlink_kernel;}
    Logged := FALSE; {Nastaveno pro pripad, ze bychom znovu volali metodu WBEnd}
   end
end;

procedure TWBaseServer602.WndProc(var Msg: TMessage);
{Slouzi k predavani zprav (hlavniho okna MDI aplikace) WinBasi602, ktera provede
svou vlastni (nutnou) obsluhu nekterych zprav. Delphi predaji zpravy WinBasi
volanim funkce WinBaseFrameProc(Handle,Msg, WParam, LParam).
Tim, ze je fce WinBaseFrameProc(Handle,Msg, WParam, LParam) umistena do WndProc,
provede se nejdrive zpracovani zprav WinBasi a teprve pak zpracovani v Delphi
(v EventHandlerech ci MessageHandlerech atd.). Chcete-li toto poradi zmenit,
umistete vlastni zpracovani do TWBMainForm.WndProc pred volani fce
WinBaseFrameProc() ci do TMainForm.WndProc ( kde TMainForm je vase hlavni
MDI okno, ktere odvodite jako potomka tridy TWBaseServer602 ) pred volani
inherited WndProc(Msg).
}
var Ret : uns32;
begin
 if Msg.Msg <> WM_Close then
 {WM_CREATE nepredame do WinBaseFrameProc(),nebot volame Init_window_env. }
 begin
  if (Msg.Msg <> WM_CREATE) and (Msg.Msg <> WM_SIZE) then
  begin
    with Msg do Ret := WinBaseFrameProc(WindowHandle, Msg, WParam, LParam);
    if(Ret = 0) then { WinBase zpravu zpracovala : Ret = 0}
     Msg.Result := 0;
  end;
  inherited WndProc(Msg);
 end
 else close;
end;

procedure TWBaseServer602.SZMSETSTATUSTEXT(var Msg: TMessage);
{prijme-li Hlavni formular vasi MDI aplikace zpravu SZM_SETSTATUSTEXT, handler
spusti kod napsany v event handleru TWBBars.OnSetStatusText }
var i : word;
    s : string;
begin
 for i := 0 to ComponentCount -1 do
   begin
     if Components[i] is TMsgFrame then
       with TMsgFrame(Components[i]) do
       if Assigned(FOnSetStatusText) then
// Parametry winbasovske zpravy SZM_SETSTATUSTEXT :
// wParam = 0, jde-li o text
// wParam = 1, jde-li o cisla (napr interni/externi cislo zaznamu)
// lParam = vlastni text ci cislo zaznamu
       begin
         s := string(PChar(Msg.lParam));
         FOnSetStatusText(self,TWBTypObsahu(Msg.wParam), s);
       end;
   end;
end;

procedure TWBaseServer602.SZMSETTOOLBAR (var Msg: TMessage);
{prijme-li Hlavni formular vasi MDI aplikace zpravu SZM_SETTOOLBAR, handler
spusti kod napsany v event handleru TWBBars.OnSetToolBar }
var i : word;
begin
 for i := 0 to ComponentCount -1 do
   begin
     if Components[i] is TMsgFrame then
       with TMsgFrame(Components[i]) do
       if Assigned(FOnSetToolBar) then FOnSetToolBar(self,TWB_TB_Typ(Msg.wParam));
   end;
end;

{********** Slouzi ke zpracovani zprav WM_COMMAND z WinBase602 : **************}
procedure TWBaseServer602.WMCOMMAND(var Msg: TMessage);
var i : word;
begin
 inherited;
for i := 0 to ComponentCount -1 do
begin
 if Components[i] is TMsgFrame then
   with TMsgFrame(Components[i]) do
   begin

    if LOWORD(Msg.wParam) = 999 then  {999 = automaticka zprava z WinBase}
    begin
 {Automaticke zpravy prijate hlavnim MDI oknem jsou opet zaslany zpatky vzdy
  tomu pohledu, ktery zpravu vyslal. Tyto zpravy lze tedy zpracovat jak na
  urovni ramcoveho MDI okna (udalosti komponenty MsgFrame), tak na urovni
  detskeho MDI okna (odpovidajici udalosti komponenty View602):}
SendMessage(Msg.lParam,WM_COMMAND, Msg.wParam, Msg.lParam);// posli zpet pohledu
     case HIWORD(Msg.wParam) of
      NOTIF_CREATE     :   { pohled byl otevren }
        if Assigned(FOnCreate) then FOnCreate(Self,Msg);
      NOTIF_DESTROY    :   { pohled byl uzavren }
        if Assigned(FOnDestroy ) then FOnDestroy (Self,Msg);
      NOTIF_RECENTER   :   { vybran novy zaznam v pohledu }
        if Assigned(FOnRecenter ) then FOnRecenter (Self,Msg);
      NOTIF_CHANGE      :  { zmenena slozka pohledu }
        if Assigned(FOnChange ) then FOnChange (Self,Msg);
      NOTIF_RESET_RECORD:  { vybrany zaznam se prekresluje }
        if Assigned(FOnReset_Record) then FOnReset_Record(Self,Msg);
      NOTIF_RESET_VIEW  :  { cely pohled se prekresluje }
        if Assigned(FOnReset_View) then FOnReset_View(Self,Msg);
      NOTIF_SUBCURSOR   :  { pohled prechazi k subkurzoru QBE }
        if Assigned(FOnSubCursor) then FOnSubCursor(Self,Msg);
      NOTIF_SUPERCURSOR :  { pohled se vraci k superkurzoru }
        if Assigned(FOnSuperCursor) then FOnSuperCursor(Self,Msg);
      NOTIF_CREATE_DEPENDENT :{ otevren zavisly pohled }
        if Assigned(FOnCreate_Dependent) then FOnCreate_Dependent(Self,Msg);
      NOTIF_DESTROY_DEPENDENT:{ uzavren zavisly pohled }
        if Assigned(FOnDestroy_Dependent) then FOnDestroy_Dependent(Self,Msg);
      NOTIF_CREATE_EDITOR    :{ otevren textovy editor }
        if Assigned(FOnCreate_Editor) then FOnCreate_Editor(Self,Msg);
      NOTIF_DESTROY_EDITOR   :{ uzavren textovy editor }
        if Assigned(FOnDestroy_Editor) then FOnDestroy_Editor(Self,Msg);
      NOTIF_CREATE_VIEWER    :{ otevreno okno s obrazkem }
        if Assigned(FOnCreate_Viewer) then FOnCreate_Viewer(Self,Msg);
      NOTIF_DESTROY_VIEWER   :{ uzavreno okno s obrazkem }
        if Assigned(FOnDestroy_Viewer) then FOnDestroy_Viewer(Self,Msg);
      end; // case

    end; // if 999
    if (1000 < Msg.wParam) and (Msg.wParam < 60001) then {uzivatelska zprava
                            WM_COMMAND zaslana z WinBase602 ramcovemu MDI oknu}

      if Assigned(FOnOtherWMCmdFrom602) then FOnOtherWMCmdFrom602(Self,Msg);
   end;  // with
end; // for
end;

procedure Register;
begin
  RegisterComponents('WB602', [TMsgFrame]);
end;

end.
