{***************************************************************************
 * Komunikan jednotka mezi aplikanm programem v Turbo Pascalu (ci      *
 * Delphi) a WinBase602                                                    *
 * (C) Janus Drozd, 1992, 93, 94, 95, 96, 97, 98, 99                       *
 * Verze 6.0 ze dne: 19.1.1999                                             *
 ***************************************************************************}
{$X+,A-,F+}
unit WinBase;

interface

const
      OBJ_NAME_LEN = 31; { max. delka jmena databazovych objektu }

type uns32 = Cardinal;     { zakladni typy WinBase }
     sig32 = LongInt;
     uns16 = Word;
     sig16 = SmallInt;
     uns8  = Byte;
     sig8  = ShortInt;

     sigfl = Integer;     { genericke typy WinBase }
     unsfl = Cardinal;
     ttablenum = sig16;   { typy databazoveho serveru }
     tobjnum   = sig16;
     trecnum   = sig32;
     tcursnum  = sig16;
     tcurstab  = sig16;
     tattrib   = uns8;
     tcateg    = uns8;
     tright    = uns8;    { zastaraly typ }
     tdright   = uns16;   { zastaraly typ }

     tobjname  = array[0..OBJ_NAME_LEN] of char;  { jmeno objektu }
     WBUUID    = array[0..11] of uns8;

     window_id = Integer;                         { handle okna }

{************************* typ parametru t_oper ***************************}
type t_oper    = (OPER_SET, OPER_GET, OPER_GETEFF);
type t_valtype = (VT_OBJNUM, VT_NAME, VT_UUID, VT_NAME3);

{********************** Cisla systemovych tabulek *************************}
const
      TAB_TABLENUM  = 0;  { cislo tabulky tabulek }
      OBJ_TABLENUM  = 1;  { cislo tabulky objektu }
      USER_TABLENUM = 2;  { cislo tabulky uzivatelu }
      SRV_TABLENUM  = 3;  { cislo tabulky serveru }
      REPL_TABLENUM = 4;  { cislo tabulky replikacnich pravidel }
      KEY_TABLENUM  = 5;  { cislo tabulky klicu }

      DEL_ATTR_NUM = 0;  { cislo atributu "DELETED" }
      NOT_DELETED  = 0;  { hodnoty atributu: zaznam neni zruseny }
      DELETED      = 1;  {                   zaznam je zruseny}
      RECORD_EMPTY = 2;  {                   zaznam je uvolneny }

{************** Atributy systemovych tabulek TABTAB A OBJTAB **************}
      OBJ_NAME_ATR  = 3; { Jmeno objektu, STRING delky 31 znaku }
      OBJ_CATEG_ATR = 4; { Kategorie objektu, atribut typu CHAR }
      APPL_ID_ATR   = 5; { Id aplikace, k niz objekt patri, BINARY delky 12 bajtu }
      OBJ_DEF_ATR   = 6; { Definice objektu, atribut typu TEXT }
      OBJ_FLAGS_ATR = 7; { Priznaky objektu, atribut typu SHORT }

{****************************** Kategorie: ********************************}
const CATEG_TABLE     = 0;
      CATEG_USER      = 1;
      CATEG_VIEW      = 2;
      CATEG_CURSOR    = 3;
      CATEG_PGMSRC    = 4;
      CATEG_PGMEXE    = 5;
      CATEG_MENU      = 6;
      CATEG_APPL      = 7;
      CATEG_PICT      = 8;
      CATEG_GROUP     = 9;
      CATEG_ROLE      = 10;
      CATEG_CONNECTION= 11;
      CATEG_RELATION  = 12;
      CATEG_DRAWING   = 13;
      CATEG_GRAPH     = 14;
      CATEG_REPLREL   = 15;
      CATEG_PROC      = 16;
      CATEG_TRIGGER   = 17;
      CATEG_WWW       = 18;
	  CATEG_SEQ       = 20;
      CATEG_SERVER    = 26;
      CATEG_MASK      = $7f;
      IS_LINK         = $80; { spojovaci objekt }
      CATEG_DIRCUR    = 27;

{************************** struktura kernel_info *************************}
type kernel_info = record
  version : array[0..5] of char; { ASCIIZ oznaceni verze serveru }
  logged : uns16;                { pocet prihlasenych uzivatelu }
  blocksize : uns16;             { velikost clusteru }
  freeblocks : uns32;            { pocet volnych clusteru v alokacni tabulce }
  frames : uns16;                { pocet pametovych ramu }
  fixed_pages : uns8;            { pocet ramu s fixovanym obsahem }
  max_users : uns8;              { maximalni pocet pripojenych uzivatelu }
  rtp : uns8;                    { provozni parametry }
  diskspace : uns32;             { mnozstvi volneho mista na disku }
  server_name : tobjname;        { ASCIIZ jmeno serveru }
  local_free_memory : uns32;     { volna pamet u klienta }
  remote_free_memory : uns32;    { volna pamet na serveru }
  networking : integer;          { sitova prace klienta }
  owned_cursors : uns16;         { pocet otevrenych kurzoru klientem }
                   end;

cd_t = array[0..5000] of char;
cdp_t = ^cd_t;
Puns32 = ^uns32;
{************* Hodnoty slozky "modtype" v zaznamu "modifrec" **************}
const MODSTOP    = 0;
      MODLEN     = 2;
      MODIND     = 3;
      MODINT     = 4;
      MODPTR     = 5;
      MODINDPTR  = 6;

type modifrec = record
        modtype : uns8;
        case Integer of
          MODSTOP   : ( );
          MODLEN    : ( );
          MODIND    : (index  : uns16);
          MODINT    : (start  : uns32;  size : uns16);
          MODPTR    : (attr   : uns8);
          MODINDPTR : (index2 : uns16;  attr2 : uns8)
        end;

const NULL_ACCESS : modifrec = (modtype : MODSTOP);
{************************** hodnota typu money ****************************}
type monstr = record
       money_lo2 : uns16;
       money_hi4 : sig32;
              end;
{************************ Pristupova prava: *******************************}
const RIGHT_APPEND   = $04;  { pravo vkladat nove zaznamy }
      RIGHT_INSERT   = $04;  { dtto }
      RIGHT_DEL      = $08;  { pravo zrusit zaznam }
      RIGHT_NEW_READ = $10;  { pridelovat k novym zaznamum pravo cist    }
      RIGHT_NEW_WRITE= $20;  { pridelovat k novym zaznamum pravo prepsat }
      RIGHT_NEW_DEL  = $40;  { pridelovat k novym zaznamum pravo zrusit  }
      RIGHT_GRANT    = $80;  { universalni pravo poskytovat sva prava    }

{******************** Hodnoty "NONE" ruznych typu: ************************}
const NONEBOOLEAN  = -128;
      NONECHAR     = 0;
      NONEDATE     = $80000000;
      NONETIME     = $80000000;
      NONETIMESTAMP= $80000000;
{     NONEMONEY    =  nelze takto definovat, ma hodnotu 0,0,0,0,0,$80 }
      NONEINTEGER  = $80000000;
      NONESHORT    = -32768;
      NONEREAL     = -1.7001e308;
      NONESTRING   = '';
      NONEPTR      = -1;

{********************* Parametry funkce Set_sql_option ********************}
const SQLOPT_NULLEQNULL       = 1; { hodnota NULL se rovna NULL }
      SQLOPT_NULLCOMP         = 2; { NULL se porovnavat s ne-NULL hodnotami }
      SQLOPT_RD_PRIVIL_VIOL   = 4; { hodnota bez prava cteni se jevi najo NULL }
      SQLOPT_MASK_NUM_RANGE   = 8; { preteceni ciselneho typu pri konverzi vrati NULL }
      SQLOPT_MASK_INV_CHAR    =16; { nekonvertovatelny retezec znaku vrati NULL }
      SQLOPT_MASK_RIGHT_TRUNC =32; { zkraceni retezce pri konverzi se maskuje }
      SQLOPT_EXPLIC_FREE      =64; { zrusene zaznamy se uvolni az pri explicitnim Free_deleted }

{****************************** Cisla chyb: *******************************}
const NO_ERROR                 = 0;
      ANS_OK                   = 0;
      NOT_ANSWERED             = $ff;
      BAD_MODIF                = $80;
      NO_RIGHT                 = $81;
      BAD_ELEM_NUM             = $82;
      OUT_OF_TABLE             = $83;
      TABLE_FULL               = $84;
      CURSOR_MISUSE            = $85;
      BAD_OPCODE               = $86;
      CANNOT_APPEND            = $87;
      NOT_LOCKED               = $88;
      NO_DESTINATION_TAB       = $89;
      INDEX_OUT_OF_RANGE       = $8a;
      NOT_A_RECORD             = $8b;
      EMPTY                    = $8c;
      NO_OBJECT                = $8d;
      BAD_PASSWORD             = $8e;
      PTR_TO_DELETED           = $8f;
      NIL_PTR                  = $90;
      OUT_OF_KERNEL_MEMORY     = $91;
      TOO_MANY_CURSORS         = $92;
      IS_DELETED               = $93;
      INDEX_NOT_FOUND          = $94;
      OBJECT_NOT_FOUND         = $95;
      OUT_OF_APPL_MEMORY       = $96;
      BAD_DATA_SIZE            = $97;
      UNREADABLE_BLOCK         = $98;
      DEMO_VERSION             = $99;
      OUT_OF_BLOCKS            = $9a;
      REQUEST_BREAKED          = $9b;
      OS_FILE_ERROR            = $9d;
      INCOMPATIBLE_VERSION     = $9e;
      REJECTED_BY_KERNEL       = $9f;
      MUST_NOT_BE_NULL         = $a0;
      NO_BITAB                 = $a1;
      NO_MY_RIGHT              = $a2;
      IE_OUT_OF_DWORM          = $a3;  { interni chyba }
      IE_FRAME_OVERRUN         = $a4;  { interni chyba }
      IE_PAGING                = $a5;  { interni chyba }
      IE_DOUBLE_PAGE           = $a6;  { interni chyba }
      IE_OUT_OF_BSTACK         = $a7;  { interni chyba }
      TABLE_DAMAGED            = $a8;
      CANNOT_LOCK_KERNEL       = $a9;
      END_OF_VOLUME_SPACE      = $aa;  { interni zprava }
      DEADLOCK                 = $ab;
      KEY_DUPLICITY            = $ac;
      BAD_VERSION              = $ad;
      CHECK_CONSTRAIN          = $ae;
      REFERENTIAL_CONSTRAIN    = $af;
      UNPROPER_TYPE            = $b0;
      OUTER_JOIN_TOO_COMPLEX   = $b1;
      REQUEST_NESTING          = $b2;
      CANNOT_FOR_ODBC          = $b3;
      ERROR_IN_FUNCTION_ARG    = $b4;
      ODBC_CURSOR_NOT_OPEN     = $b5;
      DRIVER_NOT_CAPABLE       = $b6;
      TOO_COMPLEX_TRANS        = $b7;
      INTERNAL_SIGNAL          = $b8;
      PRIV_KEY_NOT_FOUND       = $b9;
      NO_WRITE_TOKEN           = $ba;
      WAITING_FOR_ACKN         = $bb;
      REPL_BLOCKED             = $bc;
      BAD_TOKEN_STATE          = $bd;
      BAD_TABLE_PROPERTIES     = $be;
      INDEX_DAMAGED            = $bf;
      PASSWORD_EXPIRED         = $c0;
      NO_KEY_FOUND             = $c1;
      DIFFERENT_KEY            = $c2;
      ASSERTION_FAILED         = $c3;
      SQ_INVALID_CURSOR_STATE  = $c4;  { 24000 }
      SQ_SAVEPOINT_INVAL_SPEC  = $c5;  { 3B001 }
      SQ_SAVEPOINT_TOO_MANY    = $c6;  { 3B002 }
      SQ_TRANS_STATE_ACTIVE    = $c7;  { 25001 }
      SQ_INVAL_TRANS_TERM      = $c8;  { 2D000 }
      SQ_TRANS_STATE_RDONLY    = $c9;  { 25006 }
      SQ_NUM_VAL_OUT_OF_RANGE  = $ca;  { 22003 }
      SQ_INV_CHAR_VAL_FOR_CAST = $cb;  { 22018 }
      SQ_STRING_DATA_RIGHT_TRU = $cc;  { 22001 }
      SQ_DIVISION_BY_ZERO      = $cd;  { 22012 }
      SQ_CARDINALITY_VIOLATION = $ce;  { 21000 }
      SQ_INVALID_ESCAPE_CHAR   = $cf;  { 22019 }
      SQ_CASE_NOT_FOUND_STMT   = $d0;  { 20000 }
      SQ_UNHANDLED_USER_EXCEPT = $d1;  { 45000 }
      SQ_RESIGNAL_HND_NOT_ACT  = $d2;  { 0K000 }
      SQ_EXT_ROUT_NOT_AVAIL    = $d3;  { 38001 }
      SQ_NO_RETURN_IN_FNC      = $d4;  { 2F001 }
      COLUMN_NOT_EDITABLE      = $d5;
      SQ_TRIGGERED_ACTION      = $d6;  { 09000 }
      REPLICATION_NOT_RUNNING  = $d7;
      REPL_MAIL_ERROR          = $d8;
      SQ_INVALID_CURSOR_NAME   = $d9;  { 34000 }
      ROLE_FROM_DIFF_APPL      = $da;
      SEQUENCE_EXHAUSTED       = $db;
      NO_CURRENT_VAL           = $dc;

{ Cisla varovani: }
const NO_WARNING      = 0;
      WAS_IN_TRANS    = 1;
      NOT_IN_TRANS    = 2;
      ERROR_IN_CONSTRS= 3;
      IS_NOT_DEL      = 4;
      IS_DEL          = 8;
      IS_EMPTY        = 16;
      NO_BIPTR        = 32;
      INDEX_OOR       = 64;
      DUPL_KEY        = 96;
      IS_ERROR        = 128;

{ Hodnoty vracene funkci link_kernel a interf_init }
const KSE_OK             = 0;   { bez chyby }
      KSE_WINDOWS        = 1;   { zahlcene Windows }
      KSE_INSTAL_PRESENT = 2;   { pracuje program WBINSTAL }
      KSE_ZALOHA_PRESENT = 3;   { pracuje program ZALOHA }
      KSE_WINEXEC        = 4;   { nelze spustit WBADMIN }
      KSE_NO_MEMORY      = 5;   { neni dost pameti }
      KSE_NO_CONFIG      = 6;   { nenalezen kofiguracni soubor WB.CNF }
      KSE_NO_FIL         = 7;   { jmeno serveru neni registrovano }
      KSE_DAMAGED        = 8;   { databaze je vazne poskozena }
      KSE_NO_ACCESS      = 9;   { zahlceno databazove jadro }
      KSE_SERVER_CLOSED  = 10;  { server zamcen }
      KSE_BAD_VERSION    = 11;  { chybna verze jadra }
      KSE_NETWORK_INIT   = 12;  { nedari se inicializovat sit }
      KSE_QUIT           = 13;  { nevybran zadny server }
      KSE_NOSERVER       = 14;  { nenalezen zadny server }
      KSE_CONNECTION     = 15;  { nenavazano spojeni se serverem }
      KSE_NOTASK         = 16;  { nelze vytvorit dalsi instanci }
      KSE_WBNETMEM       = 17;  { nelze spustit program WBNETMEM }
      KSE_MAXCLIENTS     = 18;  { prekrocen maximalni pocet klientu }
      KSE_SPXNOTINSTALLED= 19;  { pouzite IPX nepodporuje SPX, pravdepodobne IPXODI /A }
      KSE_MAXCONNECTION  = 20;  { prekrocen pocet relaci (connections) SPX, nastavte v shell.cfg }
      KSE_MAXSESSION     = 21;  { vycerpany relace (sessions) NetBIOSu, viz manual NetBIOSu }
      KSE_MAXNCB         = 22;  { vycerpany ridici bloky NetBIOSu, viz manual NetBIOSu }
      KSE_DBASE_OPEN     = 23;  { databaze je jiz otevrena jinym serverem }
      KSE_SERVER_NAME_USED=24;  { v siti jiz bezi databazovy server stejneho jmena }
      KSE_START_THREAD    =25;  { nelze spustit dalsi vlakno }
      KSE_SYNCHRO_OBJ     =26;  { nelze vytvorit synchronizacni objekt }
      KSE_MAPPING         =27;  { nelze mapovat pametovy soubor }
      KSE_CREATE_THREAD   =28;  { nelze vytvorit vlakno pro obsluhu klienta }
      KSE_TIMEOUT         =29;  { primo dostupny server neodpovida }
      KSE_NO_WINSOCK      =30;  { knihovna winsock neni instalovana }
      KSE_WINSOCK_ERROR   =31;  { chyba pri praci se socketem }
      KSE_SERVER_NOT_KNOWN=32;  { jmeno serveru neni registrovano }
      KSE_SERVER_PATH_NOT_SPECIF=33; { cesta k databazi serveru neni registrovana }
      KSE_NETBIOS_NAME    =34;  { nemohu pridat jmeno pro NetBIOS }
      KSE_FWNOTFOUND      =35;  { nenalezen firewall }
      KSE_FWCOMM          =36;  { nelze komunikovat s firewallem }
      KSE_FWDENIED        =37;  { firewall odmitl vytvorit propojeni }
      KSE_BAD_PASSWORD    =38;  { chyba hesla k databazovemu souboru }
      KSE_ESCAPED         =39;  { upusteno od startu serveru }
      KSE_NO_IPX          =40;  { protokol IPX neni k dispozici }
      KSE_EXPIRED          =41; { skoncila pouzitelnost produktu }
      KSE_CANNOT_CREATE_FIL=42; { nelze vytvorit databazovy soubor }
      KSE_CANNOT_OPEN_FIL  =43; { nelze otevrit databazovy soubor }
      KSE_CANNOT_OPEN_TRANS=44; { nelze otevrit transakcni soubor }
      KSE_IP_FILTER        =45; { pristup z teto IP adresy neni povolen }
      KSE_NO_SERVER_LIST   =46; { nenalezen soubor wbcgi.conf se seznamem serveru }

const NOINDEX = $ffff;   { hodnota parametru index, nejde-li o multiatribut }
      MAX_PACKAGED_REQS  = 25;  { max. pocet pozadavku v baliku }

{******* Typy atributu (vyuziji se pri volani funkce Enum_attributes) ******}
const ATT_BOOLEAN   = 1;            { Boolean }
      ATT_CHAR      = 2;            { Char }
      ATT_INT16     = 3;            { Short }
      ATT_INT32     = 4;            { Integer }
      ATT_MONEY     = 5;            { Money }
      ATT_FLOAT     = 6;            { Real }
      ATT_STRING    = 7;            { String }
      ATT_CSSTRING  = 8;            { CSString }
      ATT_CSISTRING = 9;            { CSIString }
      ATT_BINARY    =10;            { Binary }
      ATT_DATE      =11;            { Date }
      ATT_TIME      =12;            { Time }
      ATT_TIMESTAMP =13;            { Timestamp }
      ATT_PTR       =14;            { Pointer }
      ATT_BIPTR     =15;            { Bipointer }
      ATT_AUTOR     =16;            { sledovaci atribut: Autorizace }
      ATT_DATIM     =17;            { sledovaci atribut: Datumovka }
      ATT_HIST      =18;            { sledovaci atribut: Historie }
      ATT_RASTER    =19;            { Raster }
      ATT_TEXT      =20;            { Text }
      ATT_NOSPEC    =21;            { Nospec }
      ATT_SIGNAT    =22;            { Signature }

{******************** Izolace transakci ***********************************}
const READ_UNCOMMITTED = 0; 
      READ_COMMITTED   = 1;
	  REPEATABLE_READ  = 2;
	  SERIALIZABLE     = 3;

{******************** Parametr hlavniho okna WinBase **********************}
{ Cisla zprav pro okenni funkci pohledu a filtrovaci funkci }
      WM_SZM_BASE        = 1524;
      SZM_IS_VISIBLE     = WM_SZM_BASE+50;
      SZM_IS_ENABLED     = WM_SZM_BASE+51;
      SZM_GET_ACCESS     = WM_SZM_BASE+54;
      SZM_RECORD_ENTER   = WM_SZM_BASE+56;
      SZM_NEXTREC        = WM_SZM_BASE+60;
      SZM_PREVREC        = WM_SZM_BASE+61;
      SZM_FIRSTREC       = WM_SZM_BASE+62;
      SZM_LASTREC        = WM_SZM_BASE+63;
      SZM_NEXTPAGE       = WM_SZM_BASE+64;
      SZM_PREVPAGE       = WM_SZM_BASE+65;
      SZM_FIRSTITEM      = WM_SZM_BASE+66;
      SZM_LASTITEM       = WM_SZM_BASE+67;
      SZM_NEXTTAB        = WM_SZM_BASE+68;
      SZM_PREVTAB        = WM_SZM_BASE+69;
      SZM_DOWNITEM       = WM_SZM_BASE+70;
      SZM_UPITEM         = WM_SZM_BASE+71;
      SZM_INDEX          = WM_SZM_BASE+72;
      SZM_QBE            = WM_SZM_BASE+74;
      SZM_UNLIMIT        = WM_SZM_BASE+75;
      SZM_BIND           = WM_SZM_BASE+76;
      SZM_SETIPOS        = WM_SZM_BASE+77;
      SZM_INSERT         = WM_SZM_BASE+78;
      SZM_DELREC         = WM_SZM_BASE+79;
      SZM_DELALL         = WM_SZM_BASE+80;
      SZM_REC_STATUS     = WM_SZM_BASE+82;
      SZM_DELASK         = WM_SZM_BASE+83;
      SZM_DO_ACTION      = WM_SZM_BASE+84;
      SZM_SETEPOS        = WM_SZM_BASE+85;
      SZM_HELP           = WM_SZM_BASE+86;
      SZM_RESET           =WM_SZM_BASE+87;
      SZM_ORDER          = WM_SZM_BASE+88;
      SZM_PRINT          = WM_SZM_BASE+89;
      SZM_ACCEPT_Q       = WM_SZM_BASE+90;
      SZM_UNBINDDEL      = WM_SZM_BASE+91;
      SZM_GET_NAME       = WM_SZM_BASE+93;
      SZM_GET_TEXT_VAL   = WM_SZM_BASE+94;
      SZM_PUT_TEXT_VAL   = WM_SZM_BASE+95;
      SZM_GET_REF_VAL    = WM_SZM_BASE+96;
      SZM_GET_FEATURES   = WM_SZM_BASE+97;
      SZM_GET_ROW_HEADER = WM_SZM_BASE+98;
      SZM_DELETE_COLUMN  = WM_SZM_BASE+99;
      SZM_ALT_TEXT_VAL   = WM_SZM_BASE+100;
      SZM_INSERT_COLUMN  = WM_SZM_BASE+101;
      SZM_GET_TOOLBAR    = WM_SZM_BASE+102;
      SZM_SELECT_ME      = WM_SZM_BASE+103;
      SZM_LOCKS          = WM_SZM_BASE+104;
      SZM_DROP           = WM_SZM_BASE+105;
      SZM_SET_EDIT_POS   = WM_SZM_BASE+106;
      SZM_EXPORTRQ       = WM_SZM_BASE+107;
      SZM_IMPORTRQ       = WM_SZM_BASE+108;
      SZM_SETSTATUSTEXT  = WM_SZM_BASE+212;
      SZM_SETTOOLBAR     = WM_SZM_BASE+213;

{************** parametry zpravy WM_COMMAND okna editoru ********************}

      MI_FSED_SAVE        = 501;	{ 500 - Text popup }
      MI_FSED_CLOSE       = 502;

      MI_FSED_PRINT_TEXT  = 505;	{ 504 - Print popup }
      MI_FSED_PRINT_BLOCK = 506;
      MI_FSED_SELPRINTER  = 507;

      MI_FSED_CUT         = 511;	{ 510 - Edit Popup }
      MI_FSED_COPY        = 512;
      MI_FSED_PASTE       = 513;
      MI_FSED_DELETE      = 514;
      MI_FSED_HIDE        = 515;
      MI_FSED_BSAVE       = 516;
      MI_FSED_BLOAD       = 517;
      MI_FSED_ABSAVE      = 518;
      MI_FSED_SELALL      = 519;
      MI_FSED_DOSSAVE     = 520;
      MI_FSED_DOSLOAD     = 521;

      MI_FSED_WRAP        = 526;	{ 525 - Format popup }
      MI_FSED_ALIGN       = 527;
      MI_FSED_FORMAT      = 528;

      MI_FSED_FIND        = 551;	{ 550 - Search popup }
      MI_FSED_REPLACE     = 552;
      MI_FSED_REFIND      = 553;

{***** Priznaky "flags" pro Open_view, Select_records a Bind_records: *****}
const NO_EDIT      = $01;    { zakaz editace v pohledu }
      NO_INSERT    = $02;    { zakaz vkladani zaznamu }
      NO_MOVE      = $04;    { zakaz prechodu mezi zaznamy }
      NO_DELETE    = $08;    { zakaz ruseni zaznamu }
      DEL_RECS     = $10;    { zobrazovat i zrusene zaznamy }
      AUTO_CURSOR  = $40;    { uzavrit cursor pri zavirani pohledu }
      COUNT_RECS   = $80;    { spocitat zaznamy pri otevreni pohledu }
      MODAL_VIEW   = $100;   { otevrit pohled jako modalni popup okno }
      QUERY_VIEW   = $10000; { otevrit pohled pro zadavani dotazu }
      PARENT_CURSOR= $80000; { pouzit kurzor z parent-pohledu }
      MODELESS_VIEW= $100000;{ otevrit pohled jako popup okno }

{ Hodnota "base" pro Open_view, Print_view, Bind_records a Select_records *}
      NO_REDIR    = -1;

{ Cislo okna MDI-Client v aplikacich WinBase (neni-li okno vytvoreno aplikaci) }
      CLIENT_ID   = 1;

{ Parametr typu WPARAM zpravy WM_COMMAND pozadujici otevreni stranky napovedy
   cislo LOWORD(lParam) }
      IDM_HELP_GENERIC  = 239;

{ Parametry funkce Reset_view }
      RESET_VISIBLILITY = 0;     { nastaveni viditelnosti a aktivity slozek }
      RESET_CONTROLS    = 1;     { nastaveni obsahu slozek }
      RESET_DELETIONS   = 5;     { odstraneni zrusenych a pridani vlozenych zaznamu }
      RESET_CACHE       = $100;  { nove naplneni cache }
      RESET_CURSOR      = $200;  { nove otevreni kurzoru }
      RESET_SYNCHRO     = $400;  { resynchronizace subpohledu }
      RESET_COMBOS      = $800;  { nove naplneni comb }

{ Mozny posledni parametr funkci Open_view, Select_records }
      NULL_WINDOW_ID : window_id = 0;

{ Oznaceni formatu dat }
      IMPEXP_FORMAT_WINBASE      = 0;
      IMPEXP_FORMAT_TEXT_COLUMNS = 1;
      IMPEXP_FORMAT_TEXT_CSV     = 2;
      IMPEXP_FORMAT_DBASE        = 3;
      IMPEXP_FORMAT_FOXPRO       = 4;
      IMPEXP_FORMAT_ODBC         = 5;
      IMPEXP_FORMAT_CURSOR       = 6;
      IMPEXP_FORMAT_TABLE        =10;
      IMPEXP_FORMAT_TABLE_REIND  =11;

{ Predavani peska }
      TOKEN_HOLD   = 0;
      TOKEN_FREE   = 1;
      TOKEN_REQ    = 2;
      TOKEN_INVAL  = 3;
      TOKEN_HAVE_I = 4;
      TOKEN_HOLD_I = 5;

{******************* Automaticky generovane zpravy: ***********************}
const NOTIF_CREATE            =  1; { pohled byl otevren }
      NOTIF_DESTROY           =  2; { pohled byl uzavren }
      NOTIF_RECENTER          =  3; { vybran novy zaznam v pohledu }
      NOTIF_CHANGE            =  4; { zmenena slozka pohledu }
      NOTIF_RESET_RECORD      =  5; { vybrany zaznam se prekresluje }
      NOTIF_RESET_VIEW        =  6; { cely pohled se prekresluje }
      NOTIF_SUBCURSOR         =  7; { pohled prechazi k subkurzoru QBE }
      NOTIF_SUPERCURSOR       =  8; { pohled se vraci k superkurzoru }
      NOTIF_CREATE_DEPENDENT  =  9; { otevren zavisly pohled }
      NOTIF_DESTROY_DEPENDENT = 10; { uzavren zavisly pohled }
      NOTIF_CREATE_EDITOR     = 11; { otevren textovy editor }
      NOTIF_DESTROY_EDITOR    = 12; { uzavren textovy editor }
      NOTIF_CREATE_VIEWER     = 13; { otevreno okno s obrazkem }
      NOTIF_DESTROY_VIEWER    = 14; { uzavreno okno s obrazkem }
{******************** Otevreni okna aplikace ******************************}
type WBFramePars = record
                     WinMenu : integer;
                     Flags   : uns16;
                   end;

const WBF_NO_TOOLBAR   = 1;
	    WBF_NO_STATUSBAR = 2;

      WB_TB_UNKNOWN    = 0; { typy toolbaru pro SZM_SETTOOLBAR }
      WB_TB_DEFAULT    = 1;
      WB_TB_VIEW       = 2;
      WB_TB_VIEWNOMOVE = 3;
      WB_TB_VIEWPROJ   = 4;
      WB_TB_VIEWQUERY  = 5;
      WB_TB_HIST       = 6;
      WB_TB_INDEX      = 7;
      WB_TB_EDITTEXT   = 8;
      WB_TB_PREVIEW    = 9;

{** Konstanty pro property ViewSrcCateg a DataSrcCateg OLE objektu a ActiveX **}
const CTG_TABLE       = 1;
      CTG_CURSOR      = 2;
      CTG_SELECT      = 3;

      CTG_VIEWNAME    = 1;
      CTG_VIEWSRC     = 2;

{************************ Dispatch ID properties ActiveX **********************}
      DID_SERVER      = 1;
      DID_SERVERIP    = 2;
      DID_USERNAME    = 3;
      DID_PASSWORD    = 4;
      DID_APPLICATION = 5;
      DID_VIEWSRC     = 6;
      DID_DATASRC     = 7;
      DID_TOPREC      = 101;
      DID_VIEWSRCTG   = 106;
      DID_DATASRCTG   = 107;
{*************************** Dispatch ID metods ActiveX ***********************}
      DID_QBE         = 201;
      DID_SORT        = 202;
      DID_ACCEPTQ     = 203;
      DID_CANCELQ     = 204;
      DID_FIRSTREC    = 205;
      DID_PREVPAGE    = 206;
      DID_PREVREC     = 207;
      DID_NEXTREC     = 208;
      DID_NEXTPAGE    = 209;
      DID_LASTREC     = 210;
      DID_FIRSTITEM   = 211;
      DID_LASTITEM    = 212;
      DID_NEXTTAB     = 213;
      DID_PREVTAB     = 214;
      DID_UPITEM      = 215;
      DID_DOWNITEM    = 216;
      DID_CUT         = 217;
      DID_COPY        = 218;
      DID_PASTE       = 219;
      DID_INSERT      = 220;
      DID_DELREC      = 221;
      DID_DELASK      = 222;
      DID_UNBINDDEL   = 223;
      DID_PRINT       = 224;
      DID_INDEX       = 225;
      DID_LOCKS       = 226;
      DID_HELP        = 227;
      DID_ED_SAVE     = 228;
      DID_ED_FIND     = 229;
      DID_ED_REPLACE  = 230;
      DID_ED_REFIND   = 231;
      DID_ED_FORMAT   = 232;
      DID_RESET       = 301;
      DID_COMMIT      = 302;
      DID_ROLLBACK    = 303;
      DID_GETCURITEM  = 304;
      DID_GETCURPOS   = 305;
      DID_SETCURPOS   = 306;
      DID_GETITEMVAL  = 307;
      DID_SETITEMVAL  = 308;
      DID_PRINTOPT    = 309;
      DID_PRINTOPTDLG = 310;
      DID_PRINTSEL    = 311;
      DID_PRINTSELDLG = 312;
      DID_QBESTATE    = 313;
      DID_EDITTEXT    = 314;
      DID_OPENPICTURE = 315;
      DID_PICKAPPL    = 316;
      DID_EXECSTTMNTS = 317;


{************************ funkce a procedury ******************************}
type enum_attr = function (attrname : PChar;  attrtype, attrmult : uns8;
                           attrspecif : uns16) : Boolean; stdcall;
     fltproc = function : LongInt;

function Acreate_user(cdp : cdp_t;  hParent : window_id) : Boolean; stdcall;
function Active_view : window_id; stdcall;
function Add_record(curs : tcursnum;  var recs;
    numofrecs : Integer) : Boolean; stdcall;
function Alogin(parent : window_id) : Boolean; stdcall;
function Amodify_user(cdp : cdp_t;  hParent : window_id; objnum : tobjnum) :
    Boolean; stdcall;
function AReplicate(cdp : cdp_t; hParent : window_id; pull : Boolean) : Boolean;
    stdcall;
function Am_I_db_admin : Boolean; stdcall;
function cd_Am_I_db_admin(cdp : cdp_t) : Boolean; stdcall;
function answered : Boolean; stdcall;
function cd_answered(cdp : cdp_t) : Boolean; stdcall;
function Append(curs : tcurstab) : trecnum; stdcall;
function cd_Append(cdp : cdp_t; curs : tcurstab) : trecnum; stdcall;
function Appl_inst_count(var count : uns32) : Boolean; stdcall;
function cd_Appl_inst_count(cdp : cdp_t; var count : uns32) : Boolean; stdcall;
function Aset_password(cdp : cdp_t;  hParent : window_id) : Boolean; stdcall;
function AToken_control(cdp : cdp_t;  hParent : window_id;
    curstab : tcurstab;  recnum : trecnum) : Boolean; stdcall;
function Attribute_info(table : ttablenum;  attrname : PChar;
    var attrnum : tattrib;  var attrtype : uns8;  var attrmult : uns8;
    var attrspecif : uns16) : Boolean; stdcall;
function cd_Attribute_info(cdp : cdp_t; table : ttablenum;  attrname : PChar;
    var attrnum : tattrib;  var attrtype : uns8;  var attrmult : uns8;
    var attrspecif : uns16) : Boolean; stdcall;
function Available_memory(local : Boolean) : LongInt; stdcall;
function cd_Available_memory(cdp : cdp_t; local : Boolean) : LongInt; stdcall;
function Break : Boolean; stdcall;
function cd_Break(cdp : cdp_t) : Boolean; stdcall;
function C_avg(curs : tcurstab;  attrname, condition : PChar;  var res) :
    Boolean; stdcall;
function cd_C_avg(cdp : cdp_t; curs : tcurstab;  attrname, condition : PChar;  var res) :
    Boolean; stdcall;
function C_count(curs : tcurstab;  attrname, condition : PChar;
    var res : trecnum) : Boolean; stdcall;
function cd_C_count(cdp : cdp_t; curs : tcurstab;  attrname, condition : PChar;
    var res : trecnum) : Boolean; stdcall;
function C_max(curs : tcurstab;  attrname, condition : PChar;  var res) :
    Boolean; stdcall;
function cd_C_max(cdp : cdp_t; curs : tcurstab;  attrname, condition : PChar;  var res) :
    Boolean; stdcall;
function C_min(curs : tcurstab;  attrname, condition : PChar;  var res) :
    Boolean; stdcall;
function cd_C_min(cdp : cdp_t; curs : tcurstab;  attrname, condition : PChar;  var res) :
    Boolean; stdcall;
function C_sum(curs : tcurstab;  attrname, condition : PChar;  var res) :
    Boolean; stdcall;
function cd_C_sum(cdp : cdp_t; curs : tcurstab;  attrname, condition : PChar;  var res) :
    Boolean; stdcall;
function cdp_alloc : cdp_t; stdcall;
function cdp_size : sig32; stdcall;
function Chng_component_flag(cdp : cdp_t;  cat : tcateg;  var name : PChar;
   mask, setbit : Integer) : Boolean; stdcall;
function Close_cursor(curs : tcursnum) : Boolean; stdcall;
function cd_Close_cursor(cdp : cdp_t; curs : tcursnum) : Boolean; stdcall;
function Commit : Boolean; stdcall;
function cd_Commit(cdp : cdp_t) : Boolean; stdcall;
function Commit_view(hView : window_id;  can_ask, report_error : Boolean) :
    Boolean; stdcall;
function Compact_database(margin : integer) : Boolean; stdcall;
function cd_Compact_database(cdp : cdp_t; margin : integer) : Boolean; stdcall;
function Compact_table(table : ttablenum) : Boolean; stdcall;
function cd_Compact_table(cdp : cdp_t; table : ttablenum) : Boolean; stdcall;
function Connection_speed_test(var requests, kbytes : integer) : Boolean; stdcall;
function cd_Connection_speed_test(cdp : cdp_t; var requests, kbytes : integer) : Boolean; stdcall;
function Create_group(name : PChar) : Boolean; stdcall;
function Create_link(sourcename, sourceappl : PChar;  category : tcateg;
    linkname : PChar) : Boolean; stdcall;
function cd_Create_link(cdp : cdp_t; sourcename, sourceappl : PChar;  category : tcateg;
    linkname : PChar) : Boolean; stdcall;
function Create2_link(sourcename : PChar;  var sourceapplid : WBUUID;
    category : tcateg;  linkname : PChar) : Boolean; stdcall;
function cd_Create2_link(cdp : cdp_t; sourcename : PChar;  var sourceapplid : WBUUID;
    category : tcateg;  linkname : PChar) : Boolean; stdcall;
function Create_user(logname, name1, name2, name3, identif : PChar;
    var homesrv : WBUUID;  password : PChar;  var objnum : tobjnum)
    : Boolean; stdcall;
function cd_Create_user(cdp : cdp_t; logname, name1, name2, name3, identif : PChar;
    var homesrv : WBUUID;  password : PChar;  var objnum : tobjnum)
    : Boolean; stdcall;
function Current_item(hView : window_id) : integer; stdcall;
function Database_integrity(repair : Boolean;  var lost_blocks, lost_dheap,
    nonex_blocks, cross_link, damaged_tabdef : uns32) : Boolean; stdcall;
function cd_Database_integrity(cdp : cdp_t; repair : Boolean;  var lost_blocks, lost_dheap,
    nonex_blocks, cross_link, damaged_tabdef : uns32) : Boolean; stdcall;
function Data_export(objnum : tobjnum;  categ : tcateg;
    fname : PChar;  format, recode : Integer) : Boolean; stdcall;
function Data_import(tabname : PChar;  index_past : Boolean;
    fname : PChar;  format, recode : Integer) : Boolean; stdcall;
function datetime2timestamp(dt, tm : uns32) : uns32; stdcall;
function Day(dt : uns32) : integer; stdcall;
function Day_of_week(dt : uns32) : integer; stdcall;
function DefWinBaseFrameProc(hWnd : window_id;  uMsg : Integer;  wParam : Integer;
    lParam : LongInt) : LongInt; stdcall;
function WinBaseFrameProc(hWnd : window_id;  uMsg : Integer;  wParam : Integer;
    lParam : LongInt) : LongInt; stdcall;
function Define_table(name, description : PChar) : Boolean; stdcall;
function Delete(curs : tcurstab;  position : trecnum) : Boolean; stdcall;
function cd_Delete(cdp : cdp_t; curs : tcurstab;  position : trecnum) : Boolean; stdcall;
function Delete_all_records(curs : tcurstab) : Boolean; stdcall;
function cd_Delete_all_records(cdp : cdp_t; curs : tcurstab) : Boolean; stdcall;
function Edit_impexp(cdp : cdp_t; name : PChar) : Boolean; stdcall;
function Edit_privils(cdp : cdp_t;  hParent : window_id;
    var tbs : ttablenum; var recnums : trecnum;  multioper : Integer)
    : Boolean; stdcall;
function Edit_query(cdp : cdp_t; name : PChar) : Boolean; stdcall;
function Edit_relation(cdp : cdp_t;  hParent : window_id; subject1 : tcateg;
    subjnum : tobjnum;  subject2 : tcateg) : Boolean; stdcall;
function Edit_table(cdp : cdp_t; hParent : window_id; name : PChar; objnum : tobjnum) : Boolean; stdcall;
function Edit_view(cdp : cdp_t;  name : PChar) : Boolean; stdcall;
function Enable_index(table : ttablenum;  which : integer;
    enable : Boolean) : Boolean; stdcall;
function cd_Enable_index(cdp : cdp_t; table : ttablenum;  which : integer;
    enable : Boolean) : Boolean; stdcall;
function Enum_attributes(table : ttablenum;
    callback : enum_attr) : Boolean; stdcall;
function cd_Enum_attributes(cdp : cdp_t; table : ttablenum;
    callback : enum_attr) : Boolean; stdcall;
function Exec_statements(cdp : cdp_t;  statements : PChar) : Integer; stdcall;
function Export_appl(cdp : cdp_t;  hParent : window_id;
   with_data, with_role_privils, with_usergrp : Boolean) : Boolean; stdcall;
function Export_appl_ex(cdp : cdp_t;  hParent : window_id;
   with_data, with_role_privils, with_usergrp, exp_locked, back_end : Boolean) : Boolean; stdcall;
function Find_object(name : PChar;  category : tcateg;
    var position : tobjnum) : Boolean; stdcall;
function cd_Find_object(cdp : cdp_t; name : PChar;  category : tcateg;
    var position : tobjnum) : Boolean; stdcall;
function Find_object_by_id(var uuid : WBUUID;  category : tcateg;
    var position : tobjnum) : Boolean; stdcall;
function cd_Find_object_by_id(cdp : cdp_t; var uuid : WBUUID;  category : tcateg;
    var position : tobjnum) : Boolean; stdcall;
function Find2_object(name : PChar;  var appl_id : WBUUID;
    category : tcateg;  var position : tobjnum) : Boolean; stdcall;
function cd_Find2_object(cdp : cdp_t; name : PChar;  var appl_id : WBUUID;
    category : tcateg;  var position : tobjnum) : Boolean; stdcall;
function Free_deleted(table : ttablenum) : Boolean; stdcall;
function cd_Free_deleted(cdp : cdp_t; table : ttablenum) : Boolean; stdcall;
function From_xbase(tablename : PChar;  filename : PChar;
    dBase : Boolean;  filecode : Integer) : Boolean; stdcall;
function GetClient(hFrame : window_id) : window_id; stdcall;
function GetSet_fil_blocks(operation : t_oper;  var blsize : uns32) : Boolean; stdcall;
function cd_GetSet_fil_blocks(cdp : cdp_t; operation : t_oper;  var blsize : uns32) : Boolean; stdcall;
function GetSet_fil_size(operation : t_oper;  var size : uns32) : Boolean; stdcall;
function cd_GetSet_fil_size(cdp : cdp_t; operation : t_oper;  var size : uns32) : Boolean; stdcall;
function GetSet_group_role(user_or_group : tobjnum;  group_or_role : tobjnum;
    subject2 : tcateg;  operation : t_oper;
    var relation : uns32) : Boolean; stdcall;
function cd_GetSet_group_role(cdp : cdp_t; user_or_group : tobjnum;  group_or_role : tobjnum;
    subject2 : tcateg;  operation : t_oper;
    var relation : uns32) : Boolean; stdcall;
function GetSet_next_user(curs : tcurstab;  position:trecnum;  attr:tattrib;
    operation:t_oper;  valtype:t_valtype;  var value) : Boolean; stdcall;
function cd_GetSet_next_user(cdp : cdp_t; curs : tcurstab;  position:trecnum;  attr:tattrib;
    operation:t_oper;  valtype:t_valtype;  var value) : Boolean; stdcall;
function GetSet_privils(user_group_role : tobjnum;  subject_categ : tcateg;
    table : ttablenum;  recnum : trecnum;  operation : t_oper;
    var privils) : Boolean; stdcall;
function cd_GetSet_privils(cdp : cdp_t; user_group_role : tobjnum;  subject_categ : tcateg;
    table : ttablenum;  recnum : trecnum;  operation : t_oper;
    var privils) : Boolean; stdcall;
function Get_data_rights(table : ttablenum;  username : PChar;
    var rights : tright;  var rd_ri : tdright;
    var wr_ri : tdright) : Boolean; stdcall;
function Get_fcursor(hView : window_id;  var curs : tcursnum;
    var flags : uns16) : Boolean; stdcall;
function Get_info(var kinf : kernel_info) : Boolean; stdcall;
function cd_Get_info(cdp : cdp_t; var kinf : kernel_info) : Boolean; stdcall;
function Get_item_value(hView : window_id;  intrec : trecnum;
    itemid : Integer;  value : PChar) : Boolean; stdcall;
function Get_logged_user(index : integer; username, applname : PChar;  var state : integer) : Boolean; stdcall;
function cd_Get_logged_user(cdp : cdp_t; index : integer; username, applname : PChar;  var state : integer) : Boolean; stdcall;
function Get_object_rights(objname : PChar;  category : tcateg;
    username : PChar;  var rights : tright) : Boolean; stdcall;
function Get_var_address(name : PChar) : Pointer; stdcall;
function Get_view_pos(hView : window_id;
    var irec, erec : trecnum) : Boolean; stdcall;
function Hours(tm : uns32) : integer; stdcall;
function Import_appl(cdp : cdp_t; hParent : window_id; fname : PChar) : Boolean; stdcall;
function Import_appl_ex(cdp : cdp_t; hParent : window_id; fname : PChar;  flags : integer;  alternate_name : PChar) : Boolean; stdcall;
function InitWBMail(Profile, PassWord : PChar) : Boolean; stdcall;
function InitWBMail602(EmiPath, UserID, PassWord : PChar) : Boolean; stdcall;
function Init_non_mdi_env(cdp : cdp_t; hMainWindow : window_id) : Boolean; stdcall;
function Init_window_env(hFrame, hClient : window_id;
    winsub_pos, Flags : Integer) : Boolean; stdcall;
function Input_box(caption, text : PChar;  maxlen : Integer) : Boolean; stdcall;
function Insert(curs : tcurstab) : trecnum; stdcall;
function cd_Insert(cdp : cdp_t; curs : tcurstab) : trecnum; stdcall;
function Insert_object(name : PChar;  category : tcateg;
    var objnum : tobjnum) : Boolean; stdcall;
function cd_Insert_object(cdp : cdp_t; name : PChar;  category : tcateg;
    var objnum : tobjnum) : Boolean; stdcall;
function interf_init(cdp : cdp_t;  kernel : integer) : integer; stdcall;
function LetterAddAddr(Letter : uns32; Addr, aType : PChar; CC : Boolean) : Boolean; stdcall;
function LetterAddFile(Letter : uns32; fName : PChar) : Boolean; stdcall;
function LetterCreate(Subj, Msg : PChar; Flags : Cardinal; var lpLetter : uns32) : Boolean; stdcall;
function LetterSend(Letter : uns32) : Boolean; stdcall;
function Like(s1, s2 : PChar) : Boolean; stdcall;
function link_kernel(path : PChar;  display : integer) : integer; stdcall;
function Log_write(text : PChar) : Boolean; stdcall;
function cd_Log_write(cdp : cdp_t; text : PChar) : Boolean; stdcall;
function Login(username, password : PChar) : Boolean; stdcall;
function cd_Login(cdp : cdp_t; username, password : PChar) : Boolean; stdcall;
function Logout : Boolean; stdcall;
function cd_Logout(cdp : cdp_t) : Boolean; stdcall;
function Look_up(curs : tcurstab;  attrname : PChar;  var res) : trecnum; stdcall;
function cd_Look_up(cdp : cdp_t; curs : tcurstab;  attrname : PChar;  var res) : trecnum; stdcall;
function Mail_parameters(hParent : window_id;  parstring : PChar;
    buflen : Integer) : Boolean; stdcall;
function Main_menu(menudef : PChar) : Boolean; stdcall;
function Make_date(day, month, year : integer) : uns32; stdcall;
function Make_time(hours, minutes, seconds, sec1000 : integer) : uns32; stdcall;
function Message_to_clients(msg : PChar) : Boolean; stdcall;
function cd_Message_to_clients(cdp : cdp_t; msg : PChar) : Boolean; stdcall;
function Minutes(tm : uns32) : integer; stdcall;
function money2real(var m : monstr) : double; stdcall;
function Month(dt : uns32) : integer; stdcall;
function Move_data(cdp : cdp_t;  move_descr_obj : tobjnum;
   inpname : PChar;  inpobj : tobjnum;  outname : PChar;
   inpformat, outformat, inpcode, outcode: Integer;  silent : Boolean) : Boolean; stdcall;
function Next_user_name(cdp : cdp_t;  hView : window_id;  erec : trecnum) : PChar; stdcall;
function Now : uns32; stdcall;
function ODBC_create_connection(dsn_name : PChar) : uns32; stdcall;
function cd_ODBC_create_connection(cdp : cdp_t; dsn_name : PChar) : uns32; stdcall;
function ODBC_direct_connection(conn_string : PChar) : uns32; stdcall;
function cd_ODBC_direct_connection(cdp : cdp_t; conn_string : PChar) : uns32; stdcall;
function ODBC_find_connection(dsn_name : PChar) : uns32; stdcall;
function cd_ODBC_find_connection(cdp : cdp_t; dsn_name : PChar) : uns32; stdcall;
function ODBC_open_cursor(connection : uns32;  var curs : tcursnum;  query : PChar) : Boolean; stdcall;
function cd_ODBC_open_cursor(cdp : cdp_t; connection : uns32;  var curs : tcursnum;  query : PChar) : Boolean; stdcall;
function Open_cursor(cursdef : tobjnum; var curs : tcursnum) : Boolean; stdcall;
function cd_Open_cursor(cdp : cdp_t; cursdef : tobjnum; var curs : tcursnum) : Boolean; stdcall;
function Open_cursor_direct(query : PChar;
    var curs : tcursnum) : Boolean; stdcall;
function cd_Open_cursor_direct(cdp : cdp_t; query : PChar;
    var curs : tcursnum) : Boolean; stdcall;
function Open_project(projname : PChar) : Boolean; stdcall;
function Open_subcursor(supercurs : tcursnum;  subcurdef : PChar;
    var subcurs : tcursnum) : Boolean; stdcall;
function cd_Open_subcursor(cdp : cdp_t; supercurs : tcursnum;  subcurdef : PChar;
    var subcurs : tcursnum) : Boolean; stdcall;
function Open_view(viewdef : PChar;  base : tcursnum;
    flags : uns32;  position : trecnum;  var reserved;
    hParent : window_id;  var hView : window_id) : window_id; stdcall;
function Owned_cursors : integer; stdcall;
function cd_Owned_cursors(cdp : cdp_t) : integer; stdcall;
function Page_setup(hParent : window_id) : Boolean; stdcall;
function Print_copies(copies : integer;  collate : Boolean) : Boolean; stdcall;
function Print_opt(hParent : window_id) : Boolean; stdcall;
function Print_view(viewdef : PChar;  base : tcursnum;
    firstrec, lastrec : trecnum;  var reserved) : Boolean; stdcall;
function Printer_dialog(hParent : window_id) : Boolean; stdcall;
function Printer_select(printer_name, port_name : PChar;
    orientation, papersize, paperbin, quality,
    duplex, color, truetype : Integer) : Boolean; stdcall;
function QBE_state(hView : window_id) : Integer; stdcall;
function Quarter(dt : uns32) : integer; stdcall;
function Read(curs : tcurstab; position : trecnum;
    attr : tattrib; var access; var buffer) : Boolean; stdcall;
function cd_Read(cdp : cdp_t; curs : tcurstab; position : trecnum;
    attr : tattrib; var access; var buffer) : Boolean; stdcall;
function Read_ind(curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  var buffer) : Boolean; stdcall;
function cd_Read_ind(cdp : cdp_t; curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  var buffer) : Boolean; stdcall;
function Read_ind_cnt(curs : tcurstab;  position : trecnum;  attr : tattrib;
    var count : uns16) : Boolean; stdcall;
function cd_Read_ind_cnt(cdp : cdp_t; curs : tcurstab;  position : trecnum;  attr : tattrib;
    var count : uns16) : Boolean; stdcall;
function Read_len(curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  var size : uns32) : Boolean; stdcall;
function cd_Read_len(cdp : cdp_t; curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  var size : uns32) : Boolean; stdcall;
function Read_lock_record(curs : tcurstab;
    position : trecnum) : Boolean; stdcall;
function cd_Read_lock_record(cdp : cdp_t; curs : tcurstab;
    position : trecnum) : Boolean; stdcall;
function Read_lock_table(curs : tcurstab) : Boolean; stdcall;
function cd_Read_lock_table(cdp : cdp_t; curs : tcurstab) : Boolean; stdcall;
function Read_record(curs : tcurstab;  position : trecnum;  var buffer;
    datasize : uns16) : Boolean; stdcall;
function cd_Read_record(cdp : cdp_t; curs : tcurstab;  position : trecnum;  var buffer;
    datasize : uns16) : Boolean; stdcall;
function Read_unlock_record(curs : tcurstab;
    position : trecnum) : Boolean; stdcall;
function cd_Read_unlock_record(cdp : cdp_t; curs : tcurstab;
    position : trecnum) : Boolean; stdcall;
function Read_unlock_table(curs : tcurstab) : Boolean; stdcall;
function cd_Read_unlock_table(cdp : cdp_t; curs : tcurstab) : Boolean; stdcall;
function Read_var(curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  start, size : uns32;  var buffer;  var psize : uns32) : Boolean; stdcall;
function cd_Read_var(cdp : cdp_t; curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  start, size : uns32;  var buffer;  var psize : uns32) : Boolean; stdcall;
function real2money(d : double;  var m : monstr) : Boolean; stdcall;
function Rec_cnt(curs : tcurstab; var recnum : trecnum) : Boolean; stdcall;
function cd_Rec_cnt(cdp : cdp_t; curs : tcurstab; var recnum : trecnum) : Boolean; stdcall;
function Register_rec_syn(hWnd1, hWnd2 : window_id) : Boolean; stdcall;
function Relate_record(relation1, viewdef : PChar;  base : tcursnum;
    flags : uns32;  var reserved;  var hView : window_id;
    relation2 : PChar) : window_id; stdcall;
function Relist_objects : Boolean; stdcall;
function cd_Relist_objects(cdp : cdp_t) : Boolean; stdcall;
function Replicate(ServerName, ApplName : PChar; pull : Boolean) : Boolean; stdcall;
function cd_Replicate(cdp : cdp_t; ServerName, ApplName : PChar; pull : Boolean) : Boolean; stdcall;
function Repl_control(optype, opparsize : integer;  var opparam) : Boolean; stdcall;
function cd_Repl_control(cdp : cdp_t;  optype, opparsize : integer;  var opparam) : Boolean; stdcall;
function Restore_table(table : ttablenum;  filename : PChar) : Boolean; stdcall;
function Roll_back : Boolean; stdcall;
function cd_Roll_back(cdp : cdp_t) : Boolean; stdcall;
function Save_table(table : ttablenum;  filename : PChar) : Boolean; stdcall;
function Sec1000(tm : uns32) : integer; stdcall;
function Seconds(tm : uns32) : integer; stdcall;
function Select_directory(hParent : window_id;  dirname : PChar) : Boolean; stdcall;
function Select_file(hParent : window_id;  filename : PChar) : Boolean; stdcall;
function Select_records(viewdef : PChar;  base : tcursnum;
    flags : uns32;  limit : Integer;  var bindl;
    var reserved;  hParent : window_id;
    var hView : window_id) : window_id; stdcall;
function send_package : Boolean; stdcall;
function cd_send_package(cdp : cdp_t) : Boolean; stdcall;
function Set_application(applname : PChar) : Boolean; stdcall;
function cd_Set_application(cdp : cdp_t; applname : PChar) : Boolean; stdcall;
function cd_Set_application_ex(cdp : cdp_t; applname : PChar; extended : Boolean) : Boolean; stdcall;
function Set_appl_starter(categ : tcateg; objname : PChar) : Boolean; stdcall;
function cd_Set_appl_starter(cdp : cdp_t; categ : tcateg; objname : PChar) : Boolean; stdcall;
function Set_data_rights(table : ttablenum; username : PChar;
    rights : tright; rd_ri : tdright; wr_ri : tdright) : Boolean; stdcall;
function Set_ext_pos(hView : window_id;  pos : trecnum;
    itemnum : Integer) : Boolean; stdcall;
function Set_fcursor(hView : window_id;  curs : tcursnum;
    flags : uns32) : Boolean; stdcall;
function Set_int_pos(hView : window_id;  pos : trecnum;
    itemnum : Integer) : Boolean; stdcall;
function Set_item_value(hView : window_id;  intrec : trecnum;
    itemid : Integer;  value : PChar) : Boolean; stdcall;
function Set_object_rights(objname : PChar;  category : tcateg;
    username : PChar;  rights : tright) : Boolean; stdcall;
function Set_password(reserved, password : PChar) : Boolean; stdcall;
function cd_Set_password(cdp : cdp_t; reserved, password : PChar) : Boolean; stdcall;
function Set_progress_report_modulus(modulus : Integer) : Boolean; stdcall;
function cd_Set_progress_report_modulus(cdp : cdp_t; modulus : Integer) : Boolean; stdcall;
function Set_sql_option(mask, value : uns32) : Boolean; stdcall;
function cd_Set_sql_option(cdp : cdp_t; mask, value : uns32) : Boolean; stdcall;
function Set_transaction_isolation_level(level : integer) : Boolean; stdcall;
function cd_Set_transaction_isolation_level(cdp : cdp_t; level : integer) : Boolean; stdcall;
function Signalize : Boolean; stdcall;
function Signature_state(hView : window_id; recnum : trecnum; signattr : PChar)
    : integer; stdcall;
function SQL_drop(handle : uns32) : Boolean; stdcall;
function cd_SQL_drop(cdp : cdp_t; handle : uns32) : Boolean; stdcall;
function SQL_execute(statement : PChar;  var results) : Boolean; stdcall;
function cd_SQL_execute(cdp : cdp_t; statement : PChar;  var results) : Boolean; stdcall;
function SQL_exec_prepared(handle : uns32; var results; var count : integer) : Boolean; stdcall;
function cd_SQL_exec_prepared(cdp : cdp_t; handle : uns32; var results; var count : integer) : Boolean; stdcall;
function SQL_prepare(statement : PChar; var handle : uns32) : Boolean;
    stdcall;
function cd_SQL_prepare(cdp : cdp_t; statement : PChar; var handle : uns32)
    : Boolean; stdcall;
function Start_transaction : Boolean; stdcall;
function cd_Start_transaction(cdp : cdp_t) : Boolean; stdcall;
function Super_recnum(subcursor, supercursor : tcursnum;
    subrecnum : trecnum;  var superrecnum : trecnum) : Boolean; stdcall;
function cd_Super_recnum(cdp : cdp_t; subcursor, supercursor : tcursnum;
    subrecnum : trecnum;  var superrecnum : trecnum) : Boolean; stdcall;
function Sz_error : Integer; stdcall;
function cd_Sz_error(cdp : cdp_t) : Integer; stdcall;
function Sz_warning : Integer; stdcall;
function cd_Sz_warning(cdp : cdp_t) : Integer; stdcall;
function Tab_page(hView : window_id;  ID : Integer) : Integer; stdcall;
function TakeMailToRemOffice : Boolean; stdcall;
function timestamp2date(dtm : uns32) : uns32; stdcall;
function timestamp2time(dtm : uns32) : uns32; stdcall;
function To_xbase(tablename : PChar;  filename : PChar;
    dBase : Boolean;  filecode : Integer) : Boolean; stdcall;
function Today : uns32; stdcall;
function Token_control(cdp : cdp_t;  curstab : tcurstab;  recnum : trecnum;
    oper : Integer) : Boolean; stdcall;
function Translate(curs : tcursnum;  crec : trecnum;
    tbord : Integer;  var trec : trecnum) : Boolean; stdcall;
function cd_Translate(cdp : cdp_t; curs : tcursnum;  crec : trecnum;
    tbord : Integer;  var trec : trecnum) : Boolean; stdcall;
function Undelete(table : ttablenum;  position : trecnum) : Boolean; stdcall;
function cd_Undelete(cdp : cdp_t; table : ttablenum;  position : trecnum) : Boolean; stdcall;
function Uninst_table(table : ttablenum) : Boolean; stdcall;
function Used_memory(local : Boolean) : Integer; stdcall;
function cd_Used_memory(cdp : cdp_t; local : Boolean) : Integer; stdcall;
function User_in_group(user, group : tobjnum;  var state : Boolean) : Boolean; stdcall;
function User_to_group(user, group : tobjnum;  state : Boolean) : Boolean; stdcall;
function waiting(timeout : sig32) : Boolean; stdcall;
function cd_waiting(cdp : cdp_t; timeout : sig32) : Boolean; stdcall;
function Who_am_I : PChar; stdcall;
function cd_Who_am_I(cdp : cdp_t) : PChar; stdcall;
function WinBase602_version : sig32; stdcall;
function cd_WinBase602_version(cdp : cdp_t) : sig32; stdcall;
function Write(curs : tcurstab;  position : trecnum;
    attr : tattrib; var access; var buffer;
    datasize : uns16) : Boolean; stdcall;
function cd_Write(cdp : cdp_t; curs : tcurstab;  position : trecnum;
    attr : tattrib; var access; var buffer;
    datasize : uns16) : Boolean; stdcall;
function Write_ind(curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  var buffer;  datasize : uns16) : Boolean; stdcall;
function cd_Write_ind(cdp : cdp_t; curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  var buffer;  datasize : uns16) : Boolean; stdcall;
function Write_ind_cnt(curs : tcurstab;  position : trecnum;
    attr : tattrib;  count : uns16) : Boolean; stdcall;
function cd_Write_ind_cnt(cdp : cdp_t; curs : tcurstab;  position : trecnum;
    attr : tattrib;  count : uns16) : Boolean; stdcall;
function Write_len(curs : tcurstab;  position : trecnum;
    attr : tattrib;  index : uns16;  size : uns32) : Boolean; stdcall;
function cd_Write_len(cdp : cdp_t; curs : tcurstab;  position : trecnum;
    attr : tattrib;  index : uns16;  size : uns32) : Boolean; stdcall;
function Write_lock_record(curs : tcurstab;
    position : trecnum) : Boolean; stdcall;
function cd_Write_lock_record(cdp : cdp_t; curs : tcurstab;
    position : trecnum) : Boolean; stdcall;
function Write_lock_table(curs : tcurstab) : Boolean; stdcall;
function cd_Write_lock_table(cdp : cdp_t; curs : tcurstab) : Boolean; stdcall;
function Write_record(curs : tcurstab;  position : trecnum;  var buffer;
    datasize : uns16) : Boolean; stdcall;
function cd_Write_record(cdp : cdp_t; curs : tcurstab;  position : trecnum;  var buffer;
    datasize : uns16) : Boolean; stdcall;
function Write_unlock_record(curs : tcurstab;
    position : trecnum) : Boolean; stdcall;
function cd_Write_unlock_record(cdp : cdp_t; curs : tcurstab;
    position : trecnum) : Boolean; stdcall;
function Write_unlock_table(curs : tcurstab) : Boolean; stdcall;
function cd_Write_unlock_table(cdp : cdp_t; curs : tcurstab) : Boolean; stdcall;
function Write_var(curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  start, size : uns32;  var buffer) : Boolean; stdcall;
function cd_Write_var(cdp : cdp_t; curs : tcurstab;  position : trecnum;  attr : tattrib;
    index : uns16;  start, size : uns32;  var buffer) : Boolean; stdcall;
function Year(dt : uns32) : integer; stdcall;
function Yesno_box(caption, text : PChar) : Boolean; stdcall;

procedure cdp_init(cdp : cdp_t); stdcall;
procedure cdp_free(cdp : cdp_t); stdcall;
procedure CloseWBMail; stdcall;
procedure Close_all_views; stdcall;
procedure Close_view(hView : window_id); stdcall;
procedure concurrent(state : Boolean); stdcall;
procedure Draw_line(hView : window_id; x1, y1, x2, y2 : Integer;  colour : Integer); stdcall;
procedure Enable_task_switch(enable : Boolean);  stdcall;
procedure cd_Enable_task_switch(cdp : cdp_t; enable : Boolean);  stdcall;
procedure Help_file(filename : PChar); stdcall;
procedure Info_box(caption, text : PChar); stdcall;
procedure interf_close; stdcall;
procedure cd_interf_close(cdp : cdp_t); stdcall;
procedure Kernel_error_box(errnum : integer); stdcall;
procedure LetterCancel(Letter : uns32); stdcall;
procedure Pick_window(hView : window_id); stdcall;
procedure Print_margins(leftmargin, rightmargin, topmargin,
               bottommargin : Integer); stdcall;
procedure Put_pixel(hView : window_id;  x, y, colour : Integer); stdcall;
procedure Register_ext_menu(hFrame : window_id;  hHlMenu, hWinsubMenu : cardinal ); stdcall;
procedure Reset_view(hView : window_id;  intrec : trecnum;  extent : Integer); stdcall;
procedure Roll_back_view(hView : window_id); stdcall;
procedure Set_first_label(posX, posY : Integer); stdcall;
procedure Set_printer(firstrec, lastrec : trecnum;
               firstpage, lastpage, direction : Integer;  outfile : PChar;
               leftmargin : Integer); stdcall;
procedure Set_status_nums(num0, num1 : trecnum); stdcall;
procedure Set_status_text(text : PChar); stdcall;
procedure Show_help(topic : Integer); stdcall;
procedure Show_help_popup(topic : Integer); stdcall;
procedure start_package; stdcall;
procedure cd_start_package(cdp : cdp_t); stdcall;
procedure unlink_kernel; stdcall;
procedure Upcase(str : PChar); stdcall;
procedure View_pattern(viewobj : tobjnum); stdcall;

{**************************************************************************}

implementation   { Odkazy do knihoven WBKERNEL.DLL a WBPREZEN.DLL }

function Acreate_user ; external 'WBPREZEN.DLL';
function Active_view ; external 'WBPREZEN.DLL';
function Add_record ; external 'WBKERNEL.DLL';
function Alogin ; external 'WBPREZEN.DLL';
function Amodify_user ; external 'WBPREZEN.DLL';
function Am_I_db_admin ; external 'WBKERNEL.DLL';
function cd_Am_I_db_admin ; external 'WBKERNEL.DLL';
function Aset_password ; external 'WBPREZEN.DLL';
function AToken_control ; external 'WBPREZEN.DLL';
function answered ; external 'WBKERNEL.DLL';
function cd_answered ; external 'WBKERNEL.DLL';
function Append ; external 'WBKERNEL.DLL';
function cd_Append ; external 'WBKERNEL.DLL';
function Appl_inst_count ; external 'WBKERNEL.DLL';
function cd_Appl_inst_count ; external 'WBKERNEL.DLL';
function AReplicate ; external 'WBPREZEN.DLL';
function Attribute_info ; external 'WBKERNEL.DLL';
function cd_Attribute_info ; external 'WBKERNEL.DLL';
function Available_memory ; external 'WBKERNEL.DLL';
function cd_Available_memory ; external 'WBKERNEL.DLL';
function Break ; external 'WBKERNEL.DLL';
function cd_Break ; external 'WBKERNEL.DLL';
function C_avg ; external 'WBKERNEL.DLL';
function cd_C_avg ; external 'WBKERNEL.DLL';
function C_count ; external 'WBKERNEL.DLL';
function cd_C_count ; external 'WBKERNEL.DLL';
function C_max ; external 'WBKERNEL.DLL';
function cd_C_max ; external 'WBKERNEL.DLL';
function C_min ; external 'WBKERNEL.DLL';
function cd_C_min ; external 'WBKERNEL.DLL';
function C_sum ; external 'WBKERNEL.DLL';
function cd_C_sum ; external 'WBKERNEL.DLL';
function cdp_size ; external 'WBKERNEL.DLL';
function cdp_alloc ; external 'WBKERNEL.DLL';
function Chng_component_flag ; external 'WBPREZEN.DLL';
function Close_cursor ; external 'WBKERNEL.DLL';
function cd_Close_cursor ; external 'WBKERNEL.DLL';
function Commit; external 'WBKERNEL.DLL';
function cd_Commit; external 'WBKERNEL.DLL';
function Commit_view ; external 'WBPREZEN.DLL';
function Compact_database ; external 'WBKERNEL.DLL';
function cd_Compact_database ; external 'WBKERNEL.DLL';
function Compact_table ; external 'WBKERNEL.DLL';
function cd_Compact_table ; external 'WBKERNEL.DLL';
function Create_group ; external 'WBKERNEL.DLL';
function Create_link ; external 'WBKERNEL.DLL';
function Connection_speed_test ; external 'WBKERNEL.DLL';
function cd_Connection_speed_test ; external 'WBKERNEL.DLL';
function cd_Create_link ; external 'WBKERNEL.DLL';
function Create2_link ; external 'WBKERNEL.DLL';
function cd_Create2_link ; external 'WBKERNEL.DLL';
function Create_user ; external 'WBKERNEL.DLL';
function cd_Create_user ; external 'WBKERNEL.DLL';
function Current_item ; external 'WBPREZEN.DLL';
function Data_export ; external 'WBPREZEN.DLL';
function Data_import ; external 'WBPREZEN.DLL';
function Database_integrity; external 'WBKERNEL.DLL';
function cd_Database_integrity; external 'WBKERNEL.DLL';
function datetime2timestamp; external 'WBKERNEL.DLL';
function Day ; external 'WBKERNEL.DLL';
function Day_of_week ; external 'WBKERNEL.DLL';
function DefWinBaseFrameProc ; external 'WBPREZEN.DLL';
function WinBaseFrameProc ; external 'WBPREZEN.DLL';
function Define_table ; external 'WBKERNEL.DLL';
function Delete ; external 'WBKERNEL.DLL';
function cd_Delete ; external 'WBKERNEL.DLL';
function Delete_all_records ; external 'WBKERNEL.DLL';
function cd_Delete_all_records ; external 'WBKERNEL.DLL';
function Edit_impexp ; external 'WBPREZEN.DLL';
function Edit_privils ; external 'WBPREZEN.DLL';
function Edit_query ; external 'WBVIEWED.DLL';
function Edit_relation ; external 'WBPREZEN.DLL';
function Edit_table ; external 'WBVIEWED.DLL';
function Edit_view ; external 'WBVIEWED.DLL';
function Enable_index ; external 'WBKERNEL.DLL';
function cd_Enable_index ; external 'WBKERNEL.DLL';
function Enum_attributes ; external 'WBKERNEL.DLL';
function cd_Enum_attributes ; external 'WBKERNEL.DLL';
function Exec_statements ; external 'WBPREZEN.DLL';
function Export_appl ; external 'WBVIEWED.DLL';
function Export_appl_ex ; external 'WBVIEWED.DLL';
function Find_object ; external 'WBKERNEL.DLL';
function cd_Find_object ; external 'WBKERNEL.DLL';
function Find_object_by_id ; external 'WBKERNEL.DLL';
function cd_Find_object_by_id ; external 'WBKERNEL.DLL';
function Find2_object ; external 'WBKERNEL.DLL';
function cd_Find2_object ; external 'WBKERNEL.DLL';
function Free_deleted ; external 'WBKERNEL.DLL';
function cd_Free_deleted ; external 'WBKERNEL.DLL';
function From_xbase ; external 'WBKERNEL.DLL';
function GetClient ; external 'WBPREZEN.DLL';
function GetSet_fil_blocks ; external 'WBKERNEL.DLL';
function cd_GetSet_fil_blocks ; external 'WBKERNEL.DLL';
function GetSet_fil_size ; external 'WBKERNEL.DLL';
function cd_GetSet_fil_size ; external 'WBKERNEL.DLL';
function GetSet_group_role ; external 'WBKERNEL.DLL';
function cd_GetSet_group_role ; external 'WBKERNEL.DLL';
function GetSet_next_user ; external 'WBKERNEL.DLL';
function cd_GetSet_next_user ; external 'WBKERNEL.DLL';
function GetSet_privils ; external 'WBKERNEL.DLL';
function cd_GetSet_privils ; external 'WBKERNEL.DLL';
function Get_data_rights ; external 'WBKERNEL.DLL';
function Get_fcursor ; external 'WBPREZEN.DLL';
function Get_info ; external 'WBKERNEL.DLL';
function cd_Get_info ; external 'WBKERNEL.DLL';
function Get_item_value ; external 'WBPREZEN.DLL';
function Get_logged_user ; external 'WBKERNEL.DLL';
function cd_Get_logged_user ; external 'WBKERNEL.DLL';
function Get_object_rights ; external 'WBKERNEL.DLL';
function Get_var_address ; external 'WBPREZEN.DLL';
function Get_view_pos ; external 'WBPREZEN.DLL';
function Hours ; external 'WBKERNEL.DLL';
function Import_appl ; external 'WBVIEWED.DLL';
function Import_appl_ex ; external 'WBVIEWED.DLL';
function InitWBMail ; external 'WBKERNEL.DLL';
function InitWBMail602 ; external 'WBKERNEL.DLL';
function LetterCreate ; external 'WBKERNEL.DLL';
function LetterAddAddr ; external 'WBKERNEL.DLL';
function LetterAddFile ; external 'WBKERNEL.DLL';
function LetterSend ; external 'WBKERNEL.DLL';
function TakeMailToRemOffice ; external 'WBKERNEL.DLL';
function Init_non_mdi_env ; external 'WBPREZEN.DLL';
function Init_window_env ; external 'WBPREZEN.DLL';
function Input_box ; external 'WBPREZEN.DLL';
function Insert ; external 'WBKERNEL.DLL';
function cd_Insert ; external 'WBKERNEL.DLL';
function Insert_object ; external 'WBKERNEL.DLL';
function cd_Insert_object ; external 'WBKERNEL.DLL';
function interf_init ; external 'WBKERNEL.DLL';
function Like ; external 'WBKERNEL.DLL';
function link_kernel ; external 'WBKERNEL.DLL';
function Log_write ; external 'WBKERNEL.DLL';
function cd_Log_write ; external 'WBKERNEL.DLL';
function Login ; external 'WBKERNEL.DLL';
function cd_Login ; external 'WBKERNEL.DLL';
function Logout ; external 'WBKERNEL.DLL';
function cd_Logout ; external 'WBKERNEL.DLL';
function Look_up ; external 'WBKERNEL.DLL';
function cd_Look_up ; external 'WBKERNEL.DLL';
function Mail_parameters ; external 'WBPREZEN.DLL';
function Main_menu ; external 'WBPREZEN.DLL';
function Make_date ; external 'WBKERNEL.DLL';
function Message_to_clients ; external 'WBKERNEL.DLL';
function cd_Message_to_clients ; external 'WBKERNEL.DLL';
function Make_time ; external 'WBKERNEL.DLL';
function Minutes ; external 'WBKERNEL.DLL';
function money2real ; external 'WBKERNEL.DLL';
function Month ; external 'WBKERNEL.DLL';
function Move_data ; external 'WBPREZEN.DLL';
function Next_user_name ; external 'WBPREZEN.DLL';
function Now ; external 'WBKERNEL.DLL';
function ODBC_create_connection ; external 'WBKERNEL.DLL';
function cd_ODBC_create_connection ; external 'WBKERNEL.DLL';
function ODBC_direct_connection ; external 'WBKERNEL.DLL';
function cd_ODBC_direct_connection ; external 'WBKERNEL.DLL';
function ODBC_find_connection ; external 'WBKERNEL.DLL';
function cd_ODBC_find_connection ; external 'WBKERNEL.DLL';
function ODBC_open_cursor ; external 'WBKERNEL.DLL';
function cd_ODBC_open_cursor ; external 'WBKERNEL.DLL';
function Open_cursor ; external 'WBKERNEL.DLL';
function cd_Open_cursor ; external 'WBKERNEL.DLL';
function Open_cursor_direct ; external 'WBKERNEL.DLL';
function cd_Open_cursor_direct ; external 'WBKERNEL.DLL';
function Open_project ; external 'WBPREZEN.DLL';
function Open_subcursor ; external 'WBKERNEL.DLL';
function cd_Open_subcursor ; external 'WBKERNEL.DLL';
function Open_view ; external 'WBPREZEN.DLL';
function Owned_cursors ; external 'WBKERNEL.DLL';
function cd_Owned_cursors ; external 'WBKERNEL.DLL';
function Page_setup ; external 'WBPREZEN.DLL';
function Print_copies ; external 'WBPREZEN.DLL';
function Print_opt ; external 'WBPREZEN.DLL';
function Print_view ; external 'WBPREZEN.DLL';
function Printer_dialog ; external 'WBPREZEN.DLL';
function Printer_select ; external 'WBPREZEN.DLL';
function QBE_state ; external 'WBPREZEN.DLL';
function Quarter ; external 'WBKERNEL.DLL';
function Read ; external 'WBKERNEL.DLL';
function cd_Read ; external 'WBKERNEL.DLL';
function Read_ind ; external 'WBKERNEL.DLL';
function cd_Read_ind ; external 'WBKERNEL.DLL';
function Read_ind_cnt ; external 'WBKERNEL.DLL';
function cd_Read_ind_cnt ; external 'WBKERNEL.DLL';
function Read_len ; external 'WBKERNEL.DLL';
function cd_Read_len ; external 'WBKERNEL.DLL';
function Read_lock_record ; external 'WBKERNEL.DLL';
function cd_Read_lock_record ; external 'WBKERNEL.DLL';
function Read_lock_table ; external 'WBKERNEL.DLL';
function cd_Read_lock_table ; external 'WBKERNEL.DLL';
function Read_record ; external 'WBKERNEL.DLL';
function cd_Read_record ; external 'WBKERNEL.DLL';
function Read_unlock_record ; external 'WBKERNEL.DLL';
function cd_Read_unlock_record ; external 'WBKERNEL.DLL';
function Read_unlock_table ; external 'WBKERNEL.DLL';
function cd_Read_unlock_table ; external 'WBKERNEL.DLL';
function Read_var ; external 'WBKERNEL.DLL';
function cd_Read_var ; external 'WBKERNEL.DLL';
function real2money ; external 'WBKERNEL.DLL';
function Rec_cnt ; external 'WBKERNEL.DLL';
function cd_Rec_cnt ; external 'WBKERNEL.DLL';
function Register_rec_syn ; external 'WBPREZEN.DLL';
function Relate_record ; external 'WBPREZEN.DLL';
function Relist_objects ; external 'WBKERNEL.DLL';
function cd_Relist_objects ; external 'WBKERNEL.DLL';
function Replicate ; external 'WBKERNEL.DLL';
function cd_Replicate ; external 'WBKERNEL.DLL';
function Repl_control ; external 'WBKERNEL.DLL';
function cd_Repl_control ; external 'WBKERNEL.DLL';
function Restore_table ; external 'WBKERNEL.DLL';
function Roll_back ; external 'WBKERNEL.DLL';
function cd_Roll_back ; external 'WBKERNEL.DLL';
function Save_table ; external 'WBKERNEL.DLL';
function Sec1000 ; external 'WBKERNEL.DLL';
function Seconds ; external 'WBKERNEL.DLL';
function Select_directory ; external 'WBPREZEN.DLL';
function Select_file ; external 'WBPREZEN.DLL';
function Select_records ; external 'WBPREZEN.DLL';
function send_package ; external 'WBKERNEL.DLL';
function cd_send_package ; external 'WBKERNEL.DLL';
function Set_application ; external 'WBKERNEL.DLL';
function cd_Set_application ; external 'WBKERNEL.DLL';
function cd_Set_application_ex ; external 'WBKERNEL.DLL';
function Set_appl_starter; external 'WBKERNEL.DLL';
function cd_Set_appl_starter; external 'WBKERNEL.DLL';
function Set_data_rights ; external 'WBKERNEL.DLL';
function Set_ext_pos ; external 'WBPREZEN.DLL';
function Set_fcursor ; external 'WBPREZEN.DLL';
function Set_int_pos ; external 'WBPREZEN.DLL';
function Set_item_value ; external 'WBPREZEN.DLL';
function Set_object_rights ; external 'WBKERNEL.DLL';
function Set_password ; external 'WBKERNEL.DLL';
function cd_Set_password ; external 'WBKERNEL.DLL';
function Set_progress_report_modulus ; external 'WBKERNEL.DLL';
function cd_Set_progress_report_modulus ; external 'WBKERNEL.DLL';
function Set_sql_option ; external 'WBKERNEL.DLL';
function cd_Set_sql_option ; external 'WBKERNEL.DLL';
function Set_transaction_isolation_level ; external 'WBKERNEL.DLL';
function cd_Set_transaction_isolation_level ; external 'WBKERNEL.DLL';
function Signalize ; external 'WBPREZEN.DLL';
function Signature_state ; external 'WBPREZEN.DLL';
function SQL_drop ; external 'WBKERNEL.DLL';
function cd_SQL_drop ; external 'WBKERNEL.DLL';
function SQL_execute ; external 'WBKERNEL.DLL';
function cd_SQL_execute ; external 'WBKERNEL.DLL';
function SQL_exec_prepared ; external 'WBKERNEL.DLL';
function cd_SQL_exec_prepared ; external 'WBKERNEL.DLL';
function SQL_prepare ; external 'WBKERNEL.DLL';
function cd_SQL_prepare ; external 'WBKERNEL.DLL';
function Start_transaction ; external 'WBKERNEL.DLL';
function cd_Start_transaction ; external 'WBKERNEL.DLL';
function Super_recnum ; external 'WBKERNEL.DLL';
function cd_Super_recnum ; external 'WBKERNEL.DLL';
function Sz_error ; external 'WBKERNEL.DLL';
function cd_Sz_error ; external 'WBKERNEL.DLL';
function Sz_warning ; external 'WBKERNEL.DLL';
function cd_Sz_warning ; external 'WBKERNEL.DLL';
function Tab_page ; external 'WBPREZEN.DLL';
function timestamp2date ; external 'WBKERNEL.DLL';
function timestamp2time ; external 'WBKERNEL.DLL';
function To_xbase ; external 'WBKERNEL.DLL';
function Today ; external 'WBKERNEL.DLL';
function Token_control ; external 'WBPREZEN.DLL';
function Translate ; external 'WBKERNEL.DLL';
function cd_Translate ; external 'WBKERNEL.DLL';
function Undelete ; external 'WBKERNEL.DLL';
function cd_Undelete ; external 'WBKERNEL.DLL';
function Uninst_table ; external 'WBKERNEL.DLL';
function Used_memory ; external 'WBKERNEL.DLL';
function cd_Used_memory ; external 'WBKERNEL.DLL';
function User_in_group ; external 'WBKERNEL.DLL';
function User_to_group ; external 'WBKERNEL.DLL';
function waiting ; external 'WBKERNEL.DLL';
function cd_waiting ; external 'WBKERNEL.DLL';
function Who_am_I ; external 'WBKERNEL.DLL';
function cd_Who_am_I ; external 'WBKERNEL.DLL';
function WinBase602_version ; external 'WBKERNEL.DLL';
function cd_WinBase602_version ; external 'WBKERNEL.DLL';
function Write ; external 'WBKERNEL.DLL';
function cd_Write ; external 'WBKERNEL.DLL';
function Write_ind ; external 'WBKERNEL.DLL';
function cd_Write_ind ; external 'WBKERNEL.DLL';
function Write_ind_cnt ; external 'WBKERNEL.DLL';
function cd_Write_ind_cnt ; external 'WBKERNEL.DLL';
function Write_len ; external 'WBKERNEL.DLL';
function cd_Write_len ; external 'WBKERNEL.DLL';
function Write_lock_record ; external 'WBKERNEL.DLL';
function cd_Write_lock_record ; external 'WBKERNEL.DLL';
function Write_lock_table ; external 'WBKERNEL.DLL';
function cd_Write_lock_table ; external 'WBKERNEL.DLL';
function Write_record ; external 'WBKERNEL.DLL';
function cd_Write_record ; external 'WBKERNEL.DLL';
function Write_unlock_record ; external 'WBKERNEL.DLL';
function cd_Write_unlock_record ; external 'WBKERNEL.DLL';
function Write_unlock_table ; external 'WBKERNEL.DLL';
function cd_Write_unlock_table ; external 'WBKERNEL.DLL';
function Write_var ; external 'WBKERNEL.DLL';
function cd_Write_var ; external 'WBKERNEL.DLL';
function Year ; external 'WBKERNEL.DLL';
function Yesno_box ; external 'WBPREZEN.DLL';

procedure cdp_init ; external 'WBKERNEL.DLL';
procedure cdp_free ; external 'WBKERNEL.DLL';
procedure CloseWBMail ; external 'WBKERNEL.DLL';
procedure Close_all_views ; external 'WBPREZEN.DLL';
procedure Close_view ; external 'WBPREZEN.DLL';
procedure concurrent ; external 'WBKERNEL.DLL';
procedure Draw_line ; external 'WBPREZEN.DLL';
procedure Enable_task_switch ; external 'WBKERNEL.DLL';
procedure cd_Enable_task_switch ; external 'WBKERNEL.DLL';
procedure Help_file ; external 'WBPREZEN.DLL';
procedure Info_box ; external 'WBPREZEN.DLL';
procedure interf_close ; external 'WBKERNEL.DLL';
procedure cd_interf_close ; external 'WBKERNEL.DLL';
procedure Kernel_error_box; external 'WBPREZEN.DLL';
procedure LetterCancel ; external 'WBKERNEL.DLL';
procedure Pick_window ; external 'WBPREZEN.DLL';
procedure Print_margins ; external 'WBPREZEN.DLL';
procedure Put_pixel ; external 'WBPREZEN.DLL';
procedure Register_ext_menu;  external 'WBPREZEN.DLL';
procedure Reset_view ; external 'WBPREZEN.DLL';
procedure Roll_back_view ; external 'WBPREZEN.DLL';
procedure Set_first_label ; external 'WBPREZEN.DLL';
procedure Set_printer ; external 'WBPREZEN.DLL';
procedure Set_status_nums ; external 'WBPREZEN.DLL';
procedure Set_status_text ; external 'WBPREZEN.DLL';
procedure Show_help ; external 'WBPREZEN.DLL';
procedure Show_help_popup ; external 'WBPREZEN.DLL';
procedure start_package ; external 'WBKERNEL.DLL';
procedure cd_start_package ; external 'WBKERNEL.DLL';
procedure unlink_kernel ; external 'WBKERNEL.DLL';
procedure Upcase ; external 'WBKERNEL.DLL';
procedure View_pattern ; external 'WBPREZEN.DLL';

end.

